# This program is free software; you can redistribute it and/or modifytemp_collection
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
import os
import bpy
import rna_keymap_ui
import textwrap
import bpy.utils.previews
from bpy.types import (Context, Event, PropertyGroup,Menu)
from bpy_extras.io_utils import ExportHelper,ImportHelper
from .utils import *
import math

#P

def tab_name_updated(self,context):
    pass
class AddonInfo(bpy.types.PropertyGroup):
    name: bpy.props.StringProperty()
    addons: bpy.props.StringProperty()
    ordered: bpy.props.StringProperty()
class AddonInfoRename(bpy.types.PropertyGroup):
    name: bpy.props.StringProperty()
    tab_name: bpy.props.StringProperty(update=tab_name_updated)
class AddonDescriptionInfo(bpy.types.PropertyGroup):
    name: bpy.props.StringProperty()
    desc:bpy.props.StringProperty(name='Description')

def draw_filter_buttons(self, context):
    if preferences().delayed_loading_code_injected and not preferences().delayed_addons_loaded:
        self.layout.operator("cp.enableaddons",icon='FILE_REFRESH')
    layout_str=str(self.layout.introspect())
    already_drawn='bpy.ops.cp.settings' in layout_str
    draw_side=preferences().draw_side
    if context.area.type!='VIEW_3D':
        draw_side='RIGHT'
    if not already_drawn:
        if draw_side=='LEFT':
            self.layout.operator("cp.settings",icon='PREFERENCES',text="").space=context.area.type
        if context.area.type=='VIEW_3D':
            if preferences().use_dropdowns and len(preferences().dropdown_categories)>0:
                self.layout.prop(context.scene,'pap_active_dropdown_category',text="")
        row=self.layout.row(align=True)
        if draw_side=='LEFT':
            if not preferences().filtering_method=="Use N-Panel Filtering":
                row.prop(context.workspace.category_indices,f'filter_enabled{get_active_space(context.area.type)}',text="",icon='FILTER',toggle=True)
            else:
                row.prop(preferences().categories,f'filter_enabled{get_active_space(context.area.type)}',text="",icon='FILTER',toggle=True)
        row.separator(factor=1)
        pcoll=icon_collection["icons"]
        for index,a in enumerate(getattr(preferences(),f"workspace_categories{get_active_space(context.area.type)}")):
            
            #print(getattr(context.workspace,f'enabled_{index}'))
            if not preferences().filtering_method=="Use N-Panel Filtering":
                if getattr(context.workspace.category_indices,f"filter_enabled{get_active_space(context.area.type)}"):
                    if a.icon in [b for b,_,_,_,_ in ALL_ICONS_ENUM]:
                        row.operator("cp.enablecategory",text=a.name if a.icon=='NONE' else "",icon=a.icon,depress=getattr(context.workspace.category_indices,f'enabled{get_active_space(context.area.type)}_{index}')).index=index
                    else:
                        row.operator("cp.enablecategory",text=a.name if a.icon=='NONE' else "",icon_value=pcoll[a.icon].icon_id,depress=getattr(context.workspace.category_indices,f'enabled{get_active_space(context.area.type)}_{index}')).index=index
                    #row.prop(context.workspace.category_indices,f'enabled_{index}',text=a.name if a.icon=='NONE' else "",icon=a.icon)
            else:
                if getattr(preferences().categories,f"filter_enabled{get_active_space(context.area.type)}"):
                    
                    if a.icon in [b for b,_,_,_,_ in ALL_ICONS_ENUM]:
                        row.operator("cp.enablecategory",text=a.name if a.icon=='NONE' else "",icon=a.icon,depress=getattr(preferences().categories,f'enabled{get_active_space(context.area.type)}_{index}')).index=index
                    else:
                        row.operator("cp.enablecategory",text=a.name if a.icon=='NONE' else "",icon_value=pcoll[a.icon].icon_id,depress=getattr(preferences().categories,f'enabled{get_active_space(context.area.type)}_{index}')).index=index
        row.separator(factor=1)
        if draw_side=='RIGHT':
            if not preferences().filtering_method=="Use N-Panel Filtering":
                row.prop(context.workspace.category_indices,f'filter_enabled{get_active_space(context.area.type)}',text="",icon='FILTER',toggle=True)
            else:
                row.prop(preferences().categories,f'filter_enabled{get_active_space(context.area.type)}',text="",icon='FILTER',toggle=True)
            row.separator(factor=1)
            row.operator("cp.settings",icon='PREFERENCES',text="").space=context.area.type
def draw_side_changed(self, context):
    # has_bc=[a for a in bpy.types.VIEW3D_HT_header.draw._draw_funcs[:] if a.__name__=='draw_handler']
    
    if self.draw_side=='RIGHT':
        try:
            bpy.types.VIEW3D_HT_header.remove(draw_dropdowns)
        except:
            pass
        try:
            bpy.types.VIEW3D_MT_editor_menus.remove(draw_dropdowns)
        except:
            pass
        try:
            bpy.types.VIEW3D_HT_tool_header.remove(draw_filter_buttons)
        except:pass
        try:
            bpy.types.VIEW3D_HT_tool_header.remove(draw_dropdowns)
        except:pass
        if not preferences().move_dropdowns_to_toolbar:
            if not bpy.types.VIEW3D_HT_header.is_extended() or  draw_dropdowns not in bpy.types.VIEW3D_HT_header.draw._draw_funcs[:]:
                bpy.types.VIEW3D_HT_header.append(draw_dropdowns)
        else:
            if not bpy.types.VIEW3D_HT_tool_header.is_extended() or  draw_dropdowns not in bpy.types.VIEW3D_HT_tool_header.draw._draw_funcs[:]:
                bpy.types.VIEW3D_HT_tool_header.append(draw_dropdowns)
        if not bpy.types.VIEW3D_HT_tool_header.is_extended() or  draw_filter_buttons not in bpy.types.VIEW3D_HT_tool_header.draw._draw_funcs[:]:
            bpy.types.VIEW3D_HT_tool_header.append(draw_filter_buttons)
    else:
        try:
            bpy.types.VIEW3D_HT_header.remove(draw_dropdowns)
        except:
            pass
        try:
            bpy.types.VIEW3D_MT_editor_menus.remove(draw_dropdowns)
        except:
            pass
        try:
            bpy.types.VIEW3D_HT_tool_header.remove(draw_filter_buttons)
        except:
            pass
        try:
            bpy.types.VIEW3D_HT_tool_header.remove(draw_dropdowns)
        except:pass
        if not preferences().move_dropdowns_to_toolbar:
            if not bpy.types.VIEW3D_MT_editor_menus.is_extended() or  draw_dropdowns not in bpy.types.VIEW3D_MT_editor_menus.draw._draw_funcs[:]:
                bpy.types.VIEW3D_MT_editor_menus.append(draw_dropdowns)
        else:
            if not bpy.types.VIEW3D_HT_tool_header.is_extended() or  draw_dropdowns not in bpy.types.VIEW3D_HT_tool_header.draw._draw_funcs[:]:
                bpy.types.VIEW3D_HT_tool_header.prepend(draw_dropdowns)
        if not bpy.types.VIEW3D_HT_tool_header.is_extended() or  draw_filter_buttons not in bpy.types.VIEW3D_HT_tool_header.draw._draw_funcs[:]:
            bpy.types.VIEW3D_HT_tool_header.prepend(draw_filter_buttons)
    savePreferences()
def exclusion_list_changed(self, context):
    for w in self.workspace_categories:
        for a in split_keep_substring(self.addons_to_exclude):
            #print(a,w.panels))
            if a in split_keep_substring(w.panels):
                w.panels=",".join([b for b in split_keep_substring(w.panels) if b!=a])
    for w in self.workspace_categories_image_editor:
        for a in split_keep_substring(self.addons_to_exclude_image_editor):
            #print(a,w.panels))
            if a in split_keep_substring(w.panels):
                w.panels=",".join([b for b in split_keep_substring(w.panels) if b!=a])
    for w in self.workspace_categories_node_editor:
        for a in split_keep_substring(self.addons_to_exclude_node_editor):
            #print(a,w.panels))
            if a in split_keep_substring(w.panels):
                w.panels=",".join([b for b in split_keep_substring(w.panels) if b!=a])
    savePreferences()
def check_if_old_injection_exists(filename,variable_name="config_path"):
    with open(filename, 'r') as f:
        text=f.read()
        if variable_name in text:
            return True
    return False
def inject_tracking_code(filename):
    if not os.path.isdir(os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))), "config")):
        os.makedirs(os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))), "config"))
    if check_if_old_injection_exists(filename):
        data=[]
        with open(filename, 'r',newline='\n') as f:
            path=os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))), "config", "CP-PanelOrder.txt")
            
            for line in f.readlines():
                
                if "config_path=r" in line:
                    data.append(f"config_path=r'{path}'\n")
                else:
                    data.append(line)
        with open(filename, 'w',newline='\n') as f:
            if data:
                f.writelines(data)
    else:
        with open(filename, 'r') as f:
            
            text = f.read()
            path=os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))), "config", "CP-PanelOrder.txt")
            text = text.replace("""system_resource,
)""",f"""system_resource,
)
import inspect
import os
import time
config_path=r'{path}'
try:
    mtime = os.path.getmtime(config_path) if os.path.exists(config_path) else 0
    if time.time()-mtime>10:
        with open(config_path, mode='w', newline='\\n', encoding='utf-8') as file:
            print('Creating Blank CP-PanelOrder file..')
except Exception as e:
    print(e)
panels=[]
scripts_directory=os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(__file__)))),"startup")
def register_class(cl,write_to_file=True):
    try:
        if write_to_file and issubclass(cl,_bpy.types.Panel) and scripts_directory not in getattr(inspect.getmodule(cl),'__file__',""):
            with open(config_path, mode='a', newline='\\n', encoding='utf-8') as file:
                panels.append(cl.__name__)
                file.write(cl.__name__+'\\n')
    except Exception as e:
        print(e)
    register_class_og(cl)""")
            text=text.replace("""register_class,
    resource_path,""","""register_class as register_class_og,
    resource_path,""")

        with open(filename, 'w') as f:
            f.write(text)
def inject_code(filename):
    if check_if_old_injection_exists(filename):
        data=[]
        with open(filename, 'r',newline='\n') as f:
            path=os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))), "config", "CP-config.txt")
            
            for line in f.readlines():
                
                if "config_path=r" in line:
                    data.append(f"    config_path=r'{path}'\n")
                else:
                    data.append(line)
        with open(filename, 'w',newline='\n') as f:
            if data:
                f.writelines(data)
    else:
        with open(filename, 'r') as f:
            
            text = f.read()
            path=os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))), "config", "CP-config.txt")
            text = text.replace("for addon in _preferences.addons:","import os")
            text = text.replace("    enable(addon.module)",f"config_path=r'{path}'")
            text1=text[:text.index(f"config_path=r'{path}'")+len(f"config_path=r'{path}'")]
            text2=text[text.index(f"config_path=r'{path}'")+len(f"config_path=r'{path}'"):]
            final_text=text1+"""
    order_of_addons=[]
    if os.path.isfile(config_path):
        with open(config_path, mode='r', newline='\\n', encoding='utf-8') as file:
            prefs = file.readlines()
            for p in prefs:
                try:
                    attr = p[:p.index("=>")]
                    type = p[p.index("=>")+2:p.index("===")]
                    value = p[p.index("===")+3:]
                    value = value.replace("\\n", "")
                    if attr =='addon_order' and type=='order':
                        panels=value[value.index(">>")+2:]
                        order_of_addons=panels.split(',')
                except:
                    pass
        
    for addon in order_of_addons:
        if addon in [a.module for a in _preferences.addons]:
            enable(addon)
    
    for addon in _preferences.addons:
        if addon.module not in order_of_addons:
            enable(addon.module)"""+text2

        with open(filename, 'w') as f:
            f.write(final_text)
def remove_delayed_load_code(filename):
    if check_if_old_injection_exists(filename,variable_name="atl_file"):
        
        with open(filename, 'r') as f:
            
            text = f.read()
            path=os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))), "config", "CP-Addons To Load on Boot.txt")
            text=text.replace("atl_file=","#Line_To_Remove")
            if bpy.app.version>=(4,0,0):
                text = text.replace("""
def reset_all(*, reload_scripts=False,cp=False):
    import sys

    # initializes addons_fake_modules
    modules_refresh()
    import os""","")
                text = text.replace("""
    addons_to_load_on_boot=['CleanPanels',]
    if os.path.exists(atl_file):
        with open(atl_file,mode='r') as f:
            for line in f.readlines():
                addons_to_load_on_boot.append(line.strip())
    for path, pkg_id in _paths_with_extension_repos():
        if not pkg_id:
            _bpy.utils._sys_path_ensure_append(path)
        
        for mod_name, _mod_path in _bpy.path.module_names(path, package=pkg_id):
            
            if cp or mod_name in addons_to_load_on_boot or os.path.dirname(os.path.dirname(os.path.dirname(sys.executable))) in _mod_path:
                is_enabled, is_loaded = check(mod_name)
                # first check if reload is needed before changing state.
                if reload_scripts:
                    import importlib
                    mod = sys.modules.get(mod_name)
                    if mod:
                        importlib.reload(mod)

                if is_enabled == is_loaded:
                    pass
                elif is_enabled:
                    enable(mod_name)
                elif is_loaded:
                    print("	addon_utils.reset_all unloading", mod_name)
                    disable(mod_name)""","")
            else:
                text = text.replace("""    addons_to_load_on_boot=['CleanPanels',]
    if os.path.exists(atl_file):
        with open(atl_file,mode='r') as f:
            for line in f.readlines():
                addons_to_load_on_boot.append(line.strip())
    
    for addon in _preferences.addons:
        if addon.module in addons_to_load_on_boot:
            enable(addon.module)""","""
    for addon in _preferences.addons:
        enable(addon.module)""")
            
            text = text.replace("def reset_all_cp_old(","def reset_all(")
        final_text=text
        with open(filename, 'w') as f:
            f.write(final_text)
    
def inject_delayed_load_code(filename):
    if check_if_old_injection_exists(filename,variable_name="atl_file"):
        data=[]
        with open(filename, 'r',newline='\n') as f:
            path=os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))), "config", "CP-Addons To Load on Boot.txt")
            
            for line in f.readlines():
                
                if "atl_file=r" in line:
                    data.append(f"    atl_file=r'{path}'\n")
                else:
                    data.append(line)
        with open(filename, 'w',newline='\n') as f:
            if data:
                f.writelines(data)
    else:
        with open(filename, 'r') as f:
            
            text = f.read()
            path=os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))), "config", "CP-Addons To Load on Boot.txt")
            if bpy.app.version<(4,0,0):
                txt_to_replace="""    for addon in _preferences.addons:
        enable(addon.module)"""
                replacement_text="""
    import os
    atl_file=cp_config_file_path
    addons_to_load_on_boot=['CleanPanels',]
    if os.path.exists(atl_file):
        with open(atl_file,mode='r') as f:
            for line in f.readlines():
                addons_to_load_on_boot.append(line.strip())
    
    for addon in _preferences.addons:
        if addon.module in addons_to_load_on_boot:
            enable(addon.module)"""
                text=text.replace(txt_to_replace,replacement_text)
                final_text=text
            else:
                text = text.replace("reset_all(","reset_all_cp_old(")
                if "order_of_addons" in text:
                    if "if addon.module in ['CleanPanels',]" not in text:
                        text=text.replace("            enable(addon.module)","            if addon.module in ['CleanPanels',]:\n                enable(addon.module)")
                        text=text.replace("            enable(addon)","            if addon in ['CleanPanels',]:\n                enable(addon)")
                else:
                    if "if addon.module in ['CleanPanels',]" not in text:
                        text=text.replace("        enable(addon.module)","        if addon.module in ['CleanPanels',]:\n            enable(addon.module)")
                text1=text[:text.index(f"def reset_all_cp_old")]
                text2=text[text.index(f"def reset_all_cp_old"):]
                insert_for_blender4="""
def reset_all(*, reload_scripts=False,cp=False):
    import sys

    # initializes addons_fake_modules
    modules_refresh()
    import os
    atl_file=cp_config_file_path
    addons_to_load_on_boot=['CleanPanels',]
    if os.path.exists(atl_file):
        with open(atl_file,mode='r') as f:
            for line in f.readlines():
                addons_to_load_on_boot.append(line.strip())
    for path, pkg_id in _paths_with_extension_repos():
        if not pkg_id:
            _bpy.utils._sys_path_ensure_append(path)
        
        for mod_name, _mod_path in _bpy.path.module_names(path, package=pkg_id):
            
            if cp or mod_name in addons_to_load_on_boot or os.path.dirname(os.path.dirname(os.path.dirname(sys.executable))) in _mod_path:
                is_enabled, is_loaded = check(mod_name)
                # first check if reload is needed before changing state.
                if reload_scripts:
                    import importlib
                    mod = sys.modules.get(mod_name)
                    if mod:
                        importlib.reload(mod)

                if is_enabled == is_loaded:
                    pass
                elif is_enabled:
                    enable(mod_name)
                elif is_loaded:
                    print("\taddon_utils.reset_all unloading", mod_name)
                    disable(mod_name)
"""
            
                final_text=text1+(insert_for_blender4)+text2
        final_text=final_text.replace("cp_config_file_path",f"r'{path}'")
        with open(filename, 'w') as f:
            f.write(final_text)
    
kmaps_object_mode = ["cp.callcategoriespie","cp.togglefiltering","cp.callwspie" ,"cp.callpanelslist","cp.quickfocus"]
def draw_addons_list(layout,context,space='VIEW_3D'):
    space="_"+space
    if space=='_VIEW_3D':
        space=''
    layout.label(text="N-Panel Order")
    column = layout.column()
    column = column.split(factor=0.9)
    column.template_list("CP_UL_Addons_Order_List", "", preferences(), f"addon_info{space.lower()}",
                                preferences(), f"addon_info{space.lower()}_index" ,item_dyntip_propname='name')
    column = column.column(align=True)
    column.operator("cp.loadaddons",
                    text="", icon="FILE_REFRESH")
    column.separator()
    column.operator("cp.moveaddon", text="", icon="SORT_DESC").direction='UP'
    column.operator("cp.moveaddon", text="", icon="SORT_ASC").direction='DOWN'
def draw_addons_list_for_renaming(layout,context,space='VIEW_3D'):
    space="_"+space
    if space=='_VIEW_3D':
        space=''
    
    layout.label(text="N-Panel Renaming")
    column = layout.column()
    column = column.split(factor=0.9)
    column.template_list("CP_UL_Addons_Order_List_For_Renaming", "", preferences(), f"addon_info_for_renaming{space.lower()}",
                                preferences(), f"addon_info_for_renaming{space.lower()}_index" ,item_dyntip_propname='name')
    column = column.column(align=True)
    column.operator("cp.loadaddonsforrenaming",
                    text="", icon="FILE_REFRESH")
    column.separator()
    column.operator("cp.resettabname",
                    text="", icon="LOOP_BACK")



def draw_hotkeys(col,km_name):
    kc = bpy.context.window_manager.keyconfigs.user
    for kmi in kmaps_object_mode:
        km2=kc.keymaps[km_name]
        kmi2=[]
        for a,b in km2.keymap_items.items():
            if a==kmi:
                kmi2.append(b)
        if kmi2:
            for a in kmi2:
                col.context_pointer_set("keymap", km2)
                rna_keymap_ui.draw_kmi([], kc, km2, a, col, 0)
def draw_settings(instance,self, context,is_preferences=True):
        layout = instance.layout
        
        if is_preferences:
            layout.prop(self,'show_advanced',toggle=True)
            if self.show_advanced:
                self.layout.prop(self,'custom_icons_dir')
                self.layout.label(text="Clean Up method for N-Panel (Restart Blender after changing this):")
                self.layout.row().prop(self,'filtering_method',expand=True)
                self.layout.prop(self,'sort_focus_menu_based_on_clicks')
                self.layout.prop(self,'filtering_per_workspace')
                self.layout.prop(self,'remove_holder_tab')
                self.layout.prop(self,'show_delete_buttons_in_quick_settings')
                self.layout.prop(self,'use_enum_search_for_popups')
                self.layout.prop(self,'filter_internal_tabs')
                self.layout.operator("cp.resetconfig",icon='ERROR')
        if self.show_advanced:
            if is_preferences:
                layout.prop(self,'experimental')
                if self.experimental:
                    
                    layout.label(text="Make sure you backup your addon directory before using Experimental Features!",icon='ERROR')
                    layout.prop(self,'auto_backup_addons')
            
        if is_preferences:
            draw_hotkeys(layout, "3D View")
        layout.prop(self,'draw_side')
        if is_preferences:
            layout.prop(self,'use_sticky_popup')
        if is_preferences or self.show_enabledisable_in_quick_settings:
            layout.operator("cp.addonsinfo",icon='SCRIPTPLUGINS')
            if is_preferences:
                layout.prop(self,'show_enabledisable_in_quick_settings')
        layout2 = layout
        layout.row().prop(self,'space_type',expand=True)
        if True :
            if self.show_advanced:  
                if is_preferences:
                    layout3 = layout2.box()
                    row = layout3.row(align=True)
                    row.alignment = 'LEFT'
                    
                    
                    row.prop(self, "show_npanel_ordering", emboss=False,
                            icon="TRIA_DOWN" if self.show_npanel_ordering else "TRIA_RIGHT")
                    
                    if self.show_npanel_ordering:
                        row = layout3.column()
                        if  self.filtering_method=="Use N-Panel Filtering":
                            row.prop(self, "sort_per_category",toggle=True)
                        if not self.injected_code and not self.filtering_method=="Use N-Panel Filtering":
                            row.label(text="Click this button before reordering the tabs!" if not self.filtering_method=="Use N-Panel Filtering" else 'Click this button for proper ordering of sub-panels in a Tab!',icon='ERROR')
                            row.operator("cp.injectcode")
                        if  not self.injected_code_tracking and self.filtering_method=="Use N-Panel Filtering":
                            row.label(text="Click this button before reordering the tabs!" if not self.filtering_method=="Use N-Panel Filtering" else 'Click this button for proper ordering of sub-panels in a Tab!',icon='ERROR')
                            row.operator("cp.injecttrackingcode")
                        draw_addons_list(row,context,self.space_type)
                        if not self.filtering_method=="Use N-Panel Filtering":
                            row.operator("cp.clearforcedorders")
                        else:
                            row.operator("cp.changecategory",text="Confirm" if preferences().filtering_method=="Use N-Panel Filtering" else "Confirm (This will change category in the source file)")
                        
                    if self.experimental or self.filtering_method=="Use N-Panel Filtering":
                        layout3 = layout2.box()
                        row = layout3.row(align=True)
                        row.alignment = 'LEFT'
                        
                        
                        row.prop(self, "show_npanel_renaming", emboss=False,
                            icon="TRIA_DOWN" if self.show_npanel_renaming else "TRIA_RIGHT")
                        if self.show_npanel_renaming:
                            row = layout3.column()
                            draw_addons_list_for_renaming(row,context,self.space_type)
                            row.operator("cp.changecategory",text="Confirm" if preferences().filtering_method=="Use N-Panel Filtering" else "Confirm (This will change category in the source file)")
            
            if self.space_type=='VIEW_3D':
                layout3 = layout2.box()
                row = layout3.row(align=True)
                row.alignment = 'LEFT'
                row.prop(self, "show_panel_categories", emboss=False,
                        icon="TRIA_DOWN" if self.show_panel_categories else "TRIA_RIGHT")
                if self.show_panel_categories:
                    row = layout3.column()
                    for index,a in enumerate(self.panel_categories):
                        row.separator(factor=1)
                        row.separator(factor=1)
                        box=row.box()
                        row1=box.row()
                        row1=row1.split(factor=0.7)
                        
                        row1.prop(a,'name',text="")
                        row2=row1.split(factor=0.75)
                        op = row2.operator('cp.remove_category', text='',
                                        icon='PANEL_CLOSE')
                        op.index = index
                        
                        op = row2.operator('cp.movecategory', text='',
                                        icon='TRIA_UP')
                        op.index = index
                        op.category = 'Pie'
                        op.direction='UP'
                        row1=box.row()
                        row1=row1.split(factor=0.7)
                        row2=row1.row()
                        row1=row1.split(factor=0.75)
                        row2.prop(a,'panels')
                        if not a.panels:
                            row2.enabled=False
                        row1.operator("cp.search_popup",text="",icon="ADD",depress=True).index=index
                        op = row1.operator('cp.movecategory', text='',
                                        icon='TRIA_DOWN')
                        op.index = index
                        op.category = 'Pie'
                        op.direction='DOWN'
                        if is_preferences or self.show_delete_buttons_in_quick_settings:
                            grid=box.grid_flow(columns=4,row_major=True)
                            for panel in split_keep_substring(a.panels):
                                if panel:
                                    op=grid.operator("cp.remove_panel",text=panel,icon='PANEL_CLOSE')
                                    op.index=index
                                    op.panel=panel
                                    op.category="Pie"
                        
                    row.separator(factor=1)
                    row.separator(factor=1)
                    row.operator("cp.add_category").to="Pie"
                    
                    row.prop(self,'pop_out_style')
                    if self.pop_out_style=='DropDown':
                        row.prop(self,'columm_layout_for_popup')
                    row.prop(self,'use_verticle_menu')
                layout3 = layout2.box()
                row = layout3.row(align=True)
                row.alignment = 'LEFT'
                row.prop(self, "show_dropdown_categories", emboss=False,
                        icon="TRIA_DOWN" if self.show_dropdown_categories else "TRIA_RIGHT")
                
                if self.show_dropdown_categories:    
                    
                    row=layout3.column()
                    if is_preferences:
                        row.prop(self,'use_dropdowns',toggle=True)
                    for index,a in enumerate(self.dropdown_categories):
                        row.separator(factor=1)
                        row.separator(factor=1)
                        box=row.box()
                        row1=box.row()
                        row1=row1.split(factor=0.7)
                        
                        row1.prop(a,'name',text="")
                        row2=row1.split(factor=0.75)
                        op = row2.operator('cp.remove_category_from_dropdown', text='',
                                        icon='PANEL_CLOSE')
                        op.index = index
                        
                        op = row2.operator('cp.movecategory', text='',
                                        icon='TRIA_UP')
                        op.index = index
                        op.category = 'DropDown'
                        op.direction='UP'
                        
                        row1=box.row()
                        row1=row1.split(factor=0.7)
                        row2=row1.row()
                        row1=row1.split(factor=0.75)
                        row2.prop(a,'panels')
                        if not a.panels:
                            row2.enabled=False
                        row1.operator("cp.search_popup_for_dropdown",text="",icon="ADD",depress=True).index=index
                        op = row1.operator('cp.movecategory', text='',
                                        icon='TRIA_DOWN')
                        op.index = index
                        op.category = 'DropDown'
                        op.direction='DOWN'
                        if is_preferences  or self.show_delete_buttons_in_quick_settings:
                            grid=box.grid_flow(columns=4,row_major=True)
                            for panel in split_keep_substring(a.panels):
                                if panel:
                                    op=grid.operator("cp.remove_panel",text=panel,icon='PANEL_CLOSE')
                                    op.index=index
                                    op.panel=panel
                                    op.category="DropDown"
                    row.separator(factor=1)
                    row.separator(factor=1)
                    row.operator("cp.add_category").to="DropDown"
                    row.separator(factor=1)
                    row.prop(self,'move_dropdowns_to_toolbar')
                    row.prop(self,'dropdown_width')
                    row.prop(self,'show_dropdown_search')
            pcoll=icon_collection["icons"]

            layout3 = layout2.box()
            row = layout3.row(align=True)
            row.alignment = 'LEFT'
            row.prop(self, "show_workspace_categories", emboss=False,text="Workspace Addon Categories" if self.filtering_method!="Use N-Panel Filtering" else "N-Panel Categories",
                    icon="TRIA_DOWN" if self.show_workspace_categories else "TRIA_RIGHT")
            if self.show_workspace_categories:    
                row=layout3.column()
                
                for index,a in enumerate(getattr(self,f"workspace_categories{get_active_space()}")):
                    row.separator(factor=1)
                    row.separator(factor=1)
                    box=row.box()
                    row1=box.row()
                    row1=row1.split(factor=0.7)
                    
                    row1.prop(a,'name',text="")
                    row2=row1.split(factor=0.5)
                    if a.icon in ALL_ICONS:
                        row2.operator("cp.change_icon",text="Icon",icon=a.icon if a.icon else None).index=index
                    else:
                        row2.operator("cp.change_icon",text="Icon",icon_value=pcoll[a.icon].icon_id).index=index
                    row2=row2.split(factor=0.5)
                    op = row2.operator('cp.remove_category_from_workspace', text='',
                                    icon='PANEL_CLOSE')
                    op.index = index
                    
                    op = row2.operator('cp.movecategory', text='',
                                    icon='TRIA_UP')
                    op.index = index
                    op.category = 'Workspace'
                    op.direction='UP'
                    
                    row1=box.row()
                    row1=row1.split(factor=0.7)
                    row2=row1.row()
                    row1=row1.split(factor=0.77)
                    row2.prop(a,'panels')
                    if not a.panels:
                        row2.enabled=False
                    if is_preferences:
                        row3=row1.split(factor=0.72)
                        row3.operator("cp.search_popup_for_workspace",text="",icon="ADD",depress=True).index=index
                        op=row3.operator('cp.reordercategory', text='',icon_value=icon_collection["icons"]['reorder'].icon_id)
                        op.index= index
                        op.category='WORKSPACE'
                        op.exclusion_list= False
                    else:
                        row1.operator("cp.search_popup_for_workspace",text="",icon="ADD",depress=True).index=index
                    op = row1.operator('cp.movecategory', text='',
                                    icon='TRIA_DOWN')
                    op.index = index
                    op.category = 'Workspace'
                    op.direction='DOWN'
                    
                    if is_preferences or self.show_delete_buttons_in_quick_settings:
                        grid=box.grid_flow(columns=4,row_major=True)
                        for panel in split_keep_substring(a.panels):
                            if panel:
                                op=grid.operator("cp.remove_panel",text=panel,icon='PANEL_CLOSE')
                                op.index=index
                                op.panel=panel
                                op.category="Workspace"
                row.separator(factor=1)
                row.operator("cp.add_category").to="Workspace"
                row.separator(factor=1)
                row.operator("cp.autocreatecategories")
                row.separator(factor=1)
                row1=row.row()
                row1=row1.split(factor=0.9)
                row2=row1.row()
                row2.prop(self,f"addons_to_exclude{get_active_space()}")
                
                if not self.addons_to_exclude:
                    row2.enabled=False
                row1.operator("cp.search_popup_for_exclude_list",text="",icon="ADD",depress=True)
                op=row1.operator('cp.reordercategory', text='',icon_value=icon_collection["icons"]['reorder'].icon_id)
                op.exclusion_list= True
                row.separator(factor=1)
                if is_preferences or self.show_delete_buttons_in_quick_settings:
                    grid=row.grid_flow(columns=4,row_major=True)
                    for panel in split_keep_substring(getattr(self,f"addons_to_exclude{get_active_space()}")):
                        if panel:
                            op=grid.operator("cp.remove_panel",text=panel,icon='PANEL_CLOSE')
                            op.panel=panel
                            op.category="ExclusionList"
                
                
                if is_preferences and not self.remove_holder_tab:
                    row.separator(factor=1)

                    row.label(text="Tab name for filtered out panels")
                    row.prop(self,'holder_tab_name',text="")
                row.separator(factor=1)
                if is_preferences:
                    row.operator("cp.importworkspaces")
            if is_preferences:

                layout3 = layout2.box()
                
                row = layout3.row(align=True)
                row.alignment = 'LEFT'
                row.prop(self, "show_focus_panel_categories", emboss=False,
                        icon="TRIA_DOWN" if self.show_dropdown_categories else "TRIA_RIGHT")
                
                if self.show_focus_panel_categories:    
                    
                    row=layout3.column()
                    row.prop(self,'only_show_unfiltered_panels')
                    for index,a in enumerate(getattr(self,f"focus_panel_categories{get_active_space()}")):
                        row.separator(factor=1)
                        row.separator(factor=1)
                        box=row.box()
                        row1=box.row()
                        row1=row1.split(factor=0.7)
                        
                        row1.prop(a,'name',text="")
                        row2=row1.split(factor=0.75)
                        op = row2.operator('cp.remove_category_from_fp', text='',
                                        icon='PANEL_CLOSE')
                        op.index = index
                        
                        op = row2.operator('cp.movecategory', text='',
                                        icon='TRIA_UP')
                        op.index = index
                        op.category = 'FP'
                        op.direction='UP'
                        
                        row1=box.row()
                        row1=row1.split(factor=0.7)
                        row2=row1.row()
                        row1=row1.split(factor=0.75)
                        row2.prop(a,'panels')
                        if not a.panels:
                            row2.enabled=False
                        row1.operator("cp.search_popup_for_fp",text="",icon="ADD",depress=True).index=index
                        op=row1.operator('cp.reordercategory', text='',icon_value=icon_collection["icons"]['reorder'].icon_id)
                        op.index= index
                        op.category='FP'
                        op.exclusion_list= False
                        op = row1.operator('cp.movecategory', text='',
                                        icon='TRIA_DOWN')
                        op.index = index
                        op.category = 'FP'
                        op.direction='DOWN'
                        if is_preferences or self.show_delete_buttons_in_quick_settings:
                            grid=box.grid_flow(columns=4,row_major=True)
                            for panel in split_keep_substring(a.panels):
                                if panel:
                                    op=grid.operator("cp.remove_panel",text=panel,icon='PANEL_CLOSE')
                                    op.index=index
                                    op.panel=panel
                                    op.category="FP"
                    row.separator(factor=1)
                    row.separator(factor=1)
                    row.operator("cp.add_category").to="FP"
                    row.separator(factor=1)
        return layout2
class CP_UL_Addons_Order_List(bpy.types.UIList):
    def draw_item(self, context, layout, data, item, icon, active_data, active_propname):
        ob = data

        obj = item
        if self.layout_type in {'DEFAULT', 'COMPACT'}:
            if obj:
                row = layout.row()
                row.label(text=obj.name)
                row.label(text="Forced Order Found" if obj.ordered else '',icon='ERROR' if obj.ordered else 'NONE')

        elif self.layout_type in {'GRID'}:
            row = layout.row()
            row.label(text=obj.name)
            row.label(text="Forced Order Found" if obj.ordered else '',icon='ERROR' if obj.ordered else 'NONE')
class CP_UL_Category_Order_List(bpy.types.UIList):
    def draw_item(self, context, layout, data, item, icon, active_data, active_propname):
        ob = data

        obj = item
        if self.layout_type in {'DEFAULT', 'COMPACT'}:
            if obj:
                row = layout.row()
                row.label(text=obj.name)

        elif self.layout_type in {'GRID'}:
            row = layout.row()
            row.label(text=obj.name)
class CP_UL_Addons_Order_List_For_Renaming(bpy.types.UIList):
    def draw_item(self, context, layout, data, item, icon, active_data, active_propname):
        ob = data

        obj = item
        if self.layout_type in {'DEFAULT', 'COMPACT'}:
            if obj:
                row = layout.row()
                row.label(text=obj.name)
                row.prop(obj,'tab_name',text="",emboss=False)

        elif self.layout_type in {'GRID'}:
            row = layout.row()
            row.label(text=obj.name)
            row.label(text="Forced Order Found" if obj.ordered else '',icon='ERROR' if obj.ordered else 'NONE')
class PAP_OT_Add_Category(bpy.types.Operator):
    bl_idname = 'cp.add_category'
    bl_label = 'Add New Category'
    bl_description="Create a new Category for this section"
    bl_property='name'
    name: bpy.props.StringProperty(default="Category",name="Name")
    to: bpy.props.StringProperty(default="Pie")
    def draw(self, context):
        self.layout.prop(self,'name')
    def execute(self, context):
        space=get_active_space()
        if self.to=='Pie':
            t=preferences().panel_categories.add()
            t.name=self.name
        elif self.to=='Workspace':
            if len(getattr(preferences(),f'workspace_categories{space}'))<50:
                t=getattr(preferences(),f'workspace_categories{space}').add()
                t.name=self.name
            else:
                self.report({'WARNING'},"Workspace are limited to 50!")
        elif self.to=='FP':
            if len(getattr(preferences(),f'focus_panel_categories{space}'))<10:
                t=getattr(preferences(),f'focus_panel_categories{space}').add()
                t.name=self.name
            else:
                self.report({'WARNING'},"Focus Panel Categories are limited to 10!")
        else:
            t=preferences().dropdown_categories.add()
            t.name=self.name
        savePreferences()
        return {'FINISHED'}
    def invoke(self, context, event):
        return context.window_manager.invoke_props_dialog(self)
class PAP_OT_Remove_Panel(bpy.types.Operator):
    bl_idname = 'cp.remove_panel'
    bl_label = 'Remove this addon/panel'
    bl_description="Remove this Addon/Panel from this category"
    index: bpy.props.IntProperty()
    panel: bpy.props.StringProperty()
    category: bpy.props.StringProperty(default="Pie")
    def execute(self, context):
        space = get_active_space()
        if self.category=="Pie":
            preferences().panel_categories[self.index].panels=",".join([a for a in split_keep_substring(preferences().panel_categories[self.index].panels) if a and a!=self.panel])
        elif self.category=="DropDown":
            preferences().dropdown_categories[self.index].panels=",".join([a for a in split_keep_substring(preferences().dropdown_categories[self.index].panels) if a and a!=self.panel])
        elif self.category=="FP":
            getattr(preferences(),f"focus_panel_categories{space}")[self.index].panels=",".join([a for a in split_keep_substring(getattr(preferences(),f"focus_panel_categories{space}")[self.index].panels) if a and a!=self.panel])
            
        elif self.category=="Workspace":
            getattr(preferences(),f"workspace_categories{space}")[self.index].panels=",".join([a for a in split_keep_substring(getattr(preferences(),f"workspace_categories{space}")[self.index].panels) if a and a!=self.panel])
        elif self.category=="ATL":
            preferences().atl_list=",".join([a for a in split_keep_substring(preferences().atl_list) if a and a!=self.panel])
        else:
            setattr(preferences(),f"addons_to_exclude{space}",",".join([a for a in split_keep_substring(getattr(preferences(),f"addons_to_exclude{space}")) if a and a!=self.panel]))
        savePreferences()
        return {'FINISHED'}

    
class PAP_OT_Remove_Category(bpy.types.Operator):
    bl_idname = 'cp.remove_category'
    bl_label = 'Remove this Category'
    bl_description="Remove this Category"
    index: bpy.props.IntProperty()

    def execute(self, context):
        preferences().panel_categories.remove(
            self.index)
        savePreferences()
        return {'FINISHED'}
class PAP_OT_CP(bpy.types.Operator):
    bl_idname = 'cp.settings'
    bl_label = "Clean Panels"
    bl_description="Open Clean Panels quick settings"
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    bl_category = "Clean Panels"
    space:bpy.props.StringProperty(default='VIEW_3D')
    def draw(self, context):
        layout = self.layout
        layout.ui_units_x=25
        preferences().space_type=self.space
        layout.operator("cp.openpreferences",icon='TOOL_SETTINGS')
        draw_settings(self,preferences(), context,False)
        
    def execute(self, context):
        return {'FINISHED'}
    def invoke(self, context, event):
        return context.window_manager.invoke_popup(self)
class PAP_OT_Remove_Category_Dropdown(bpy.types.Operator):
    bl_idname = 'cp.remove_category_from_dropdown'
    bl_label = 'Remove this Category'
    index: bpy.props.IntProperty()
    bl_description="Remove this Category from Dropdowns section"
    def execute(self, context):
        preferences().dropdown_categories.remove(
            self.index)
        savePreferences()
        return {'FINISHED'}
class PAP_OT_Remove_Category_FP(bpy.types.Operator):
    bl_idname = 'cp.remove_category_from_fp'
    bl_label = 'Remove this Category'
    index: bpy.props.IntProperty()
    bl_description="Remove this Category from Focus Panel section"
    def execute(self, context):
        getattr(preferences(),f"focus_panel_categories{get_active_space()}").remove(
            self.index)
        savePreferences()
        return {'FINISHED'}
class PAP_OT_Remove_Category_Workspace(bpy.types.Operator):
    bl_idname = 'cp.remove_category_from_workspace'
    bl_label = 'Remove this Category'
    bl_description="Remove this category from workspace filtering"
    index: bpy.props.IntProperty()

    def execute(self, context):
        getattr(preferences(),f"workspace_categories{get_active_space()}").remove(
            self.index)
        savePreferences()
        return {'FINISHED'}
class PAP_OT_Reorder_Category(bpy.types.Operator):
    bl_idname = 'cp.reordercategory'
    bl_label = 'Reorder'
    bl_description="Change the order of Panels.\nUseful when using per category sorting(with N-Panel Filtering method)"
    index: bpy.props.IntProperty()
    exclusion_list: bpy.props.BoolProperty(default=False,options={'SKIP_SAVE','HIDDEN'})
    category:bpy.props.StringProperty()
    def draw(self, context):
        layout=self.layout
        column = layout.column()
        column = column.split(factor=0.9)
        column.template_list("CP_UL_Category_Order_List", "", context.scene, "addon_info",
                                    context.scene, "addon_info_index" ,item_dyntip_propname='name')
        column = column.column(align=True)
        column.operator("cp.moveaddonincategory", text="", icon="SORT_DESC").direction='UP'
        column.operator("cp.moveaddonincategory", text="", icon="SORT_ASC").direction='DOWN'
    def execute(self, context):
        space=get_active_space()
        if self.exclusion_list:
            setattr(preferences(),f"addons_to_exclude{space}",",".join([a.name for a in context.scene.addon_info]))
        else:
            if self.category=='FP':
                getattr(preferences(),f'focus_panel_categories{space}')[self.index].panels=",".join([a.name for a in context.scene.addon_info])
            else:
                getattr(preferences(),f'workspace_categories{space}')[self.index].panels=",".join([a.name for a in context.scene.addon_info])
        bpy.ops.cp.togglefiltering('INVOKE_DEFAULT')
        bpy.ops.cp.togglefiltering('INVOKE_DEFAULT')
        savePreferences()
        return {'FINISHED'}
    def invoke(self, context, event):
        context.scene.addon_info.clear()
        space=get_active_space()
        if self.exclusion_list:
            for a in split_keep_substring(getattr(preferences(),f'addons_to_exclude{space}')):
                t=context.scene.addon_info.add()
                t.name=a
        else:
            if self.category=='FP':
                for a in split_keep_substring(getattr(preferences(),f'focus_panel_categories{space}')[self.index].panels):
                    t=context.scene.addon_info.add()
                    t.name=a
            else:
                for a in split_keep_substring(getattr(preferences(),f'workspace_categories{space}')[self.index].panels):
                    t=context.scene.addon_info.add()
                    t.name=a
            
        return context.window_manager.invoke_props_dialog(self)
class CP_OT_Remove_Panel(bpy.types.Operator):
    bl_idname="cp.removedropdownpanel"
    bl_label="Remove this Dropdown"
    bl_options = {'REGISTER', 'UNDO'}
    name: bpy.props.StringProperty()
    def execute(self, context):
        for a in preferences().dropdown_categories:
            a.panels=",".join([b for b in split_keep_substring(a.panels) if b!=self.name and b])
        savePreferences()
        return {'FINISHED'}
class PAP_OT_searchPopup(bpy.types.Operator):
    
    bl_idname = "cp.search_popup"
    bl_label = "Add Panel"
    bl_property = "my_enum"

    my_enum: bpy.props.EnumProperty(name="Panel", description="", items=get_panel_categories)
    category: bpy.props.StringProperty(default="Pie")
    index: bpy.props.IntProperty(default=0)
    def draw(self,context):
        layout=self.layout
        grid=layout.grid_flow(columns=math.ceil(len(context.scene.temp_collection)/30))
        for t in context.scene.temp_collection:
            row=grid.row()
            row=row.split(factor=0.9)
            row.prop(t,'enabled',text=t.name)
            row.label(text='',icon=t.icon)
    def execute(self, context):
        index=self.index
        if not preferences().use_enum_search_for_popups:
            for a in context.scene.temp_collection:
                if not a.enabled:
                    preferences().panel_categories[index].panels=",".join([t for t in split_keep_substring(preferences().panel_categories[index].panels) if t!=a.name])
                    preferences().panel_categories[index].panels=",".join(split_keep_substring(preferences().panel_categories[index].panels))
            to_add=[]
            for a in context.scene.temp_collection:
                if a.enabled and a.name not in split_keep_substring(preferences().panel_categories[index].panels):
                    to_add.append(a.name)
            preferences().panel_categories[index].panels=",".join(split_keep_substring(preferences().panel_categories[index].panels)+to_add)
        else:
            
            #index=preferences().panel_categories.find(self.category)
            if index>=0:
                preferences().panel_categories[index].panels=(preferences().panel_categories[index].panels+","+self.my_enum) if preferences().panel_categories[index].panels else self.my_enum
        savePreferences()
        return {'FINISHED'}

    def invoke(self, context, event):
        wm = context.window_manager
        context.scene.temp_collection.clear()
        addons=get_panel_categories(self,context)
        self.addons=addons
        for a in addons:
            t=context.scene.temp_collection.add()
            t.name=a[0]
            t.icon=a[3]
            t.enabled=a[0] in split_keep_substring(preferences().panel_categories[self.index].panels)
        if not preferences().use_enum_search_for_popups:
            return wm.invoke_props_dialog(self,width=200*math.ceil(len(addons)/30))
        wm.invoke_search_popup(self)
        return {'FINISHED'}
def get_addons_for_atl(self,context):
    addons=[]
    for a in bpy.context.preferences.addons.keys():
        try:
            mod = sys.modules[a]
            b=mod.bl_info.get('name', "Unknown")
            if a not in addons_to_exclude:
                
                addons.append((b,mod.__name__))
        except:
            pass
    addons=sorted(addons,key=lambda x:x[0].lower())
    addons= [(b,f"{a}",b,'CHECKMARK' if b in preferences().atl_list else 'NONE',i) for i,(a,b) in enumerate(addons)]
    return addons
class PAP_OT_Set_ATL(bpy.types.Operator):
    
    bl_idname = "cp.setatl"
    bl_label = "Add Addon"
    bl_property = "my_enum"
    
    my_enum: bpy.props.EnumProperty(name="Panel", description="", items=get_addons_for_atl)
    def draw(self,context):
        layout=self.layout
        grid=layout.grid_flow(columns=math.ceil(len(context.scene.temp_collection)/30))
        for t in context.scene.temp_collection:
            row=grid.row()
            row=row.split(factor=0.9)
            row.prop(t,'enabled',text=t.name)
            # row.label(text='',icon='')
    def execute(self, context):
        if not preferences().use_enum_search_for_popups:
            for a in context.scene.temp_collection:
                if not a.enabled:
                    preferences().atl_list=",".join([t for t in split_keep_substring(preferences().atl_list) if t!=a.icon])
                    preferences().atl_list=",".join(split_keep_substring(preferences().atl_list))
            to_add=[]
            for a in context.scene.temp_collection:
                if a.enabled and a.icon not in split_keep_substring(preferences().atl_list):
                    to_add.append(a.icon)
            preferences().atl_list=",".join(split_keep_substring(preferences().atl_list)+to_add)
        else:
            preferences().atl_list=(preferences().atl_list+","+self.my_enum) if preferences().atl_list else self.my_enum
        savePreferences()
        return {'FINISHED'}

    def invoke(self, context, event):
        wm = context.window_manager
        context.scene.temp_collection.clear()
        
        self.addons=get_addons_for_atl(self,context)
        for a in self.addons:
            t=context.scene.temp_collection.add()
            t.name=a[1]
            t.icon=a[2]
            t.enabled=a[2] in split_keep_substring(preferences().atl_list)
        if not preferences().use_enum_search_for_popups:
            return wm.invoke_props_dialog(self,width=200*math.ceil(len(self.addons)/30))
        wm.invoke_search_popup(self)
        return {'FINISHED'}
class PAP_OT_searchPopupForExclusion(bpy.types.Operator):
    
    bl_idname = "cp.search_popup_for_exclude_list"
    bl_label = "Add Addon"
    bl_property = "my_enum"
    my_enum: bpy.props.EnumProperty(name="Panel", description="", items=get_all_addons)
    def draw(self,context):
        layout=self.layout
        grid=layout.grid_flow(columns=math.ceil(len(context.scene.temp_collection)/30))
        for t in context.scene.temp_collection:
            row=grid.row()
            row.prop(t,'enabled',text=t.name,icon=t.icon)
    def execute(self, context):
        if not preferences().use_enum_search_for_popups:
            for a in context.scene.temp_collection:
                name=a.name
                if a.name in ["Tool(Tab)","View(Tab)","Node(Tab)","Options(Tab)"]:
                        name=name.replace("(Tab)","")
                if not a.enabled:
                    setattr(preferences(),f'addons_to_exclude{get_active_space()}',",".join([t for t in split_keep_substring(getattr(preferences(),f'addons_to_exclude{get_active_space()}')) if t!=name]))
                    setattr(preferences(),f'addons_to_exclude{get_active_space()}',",".join(split_keep_substring(getattr(preferences(),f'addons_to_exclude{get_active_space()}'))))
                    # preferences().addons_to_exclude=",".join([t for t in split_keep_substring(preferences().addons_to_exclude) if t!=a.name])
                    # preferences().addons_to_exclude=",".join(split_keep_substring(preferences().addons_to_exclude))
            to_add=[]
            for a in context.scene.temp_collection:
                if a.enabled and a.name not in split_keep_substring(getattr(preferences(),f'addons_to_exclude{get_active_space()}')):
                    name=a.name
                    if a.name in ["Tool(Tab)","View(Tab)","Node(Tab)","Options(Tab)"]:
                            name=name.replace("(Tab)","")
                    to_add.append(name)
            setattr(preferences(),f'addons_to_exclude{get_active_space()}',",".join(split_keep_substring(getattr(preferences(),f'addons_to_exclude{get_active_space()}'))+to_add))
        else:
            if self.my_enum=='All':
                all_addons=",".join(get_all_addon_names(self,context))
                setattr(preferences(),f'addons_to_exclude{get_active_space()}',all_addons)
            elif self.my_enum=='Unfiltered':
                used_addons=[]
                for a in getattr(preferences(),f"workspace_categories{get_active_space()}"):
                    used_addons.extend(split_keep_substring(a.panels))
                all_addons=get_all_addon_names(self,context)
                addons_to_add=[b for b in all_addons if b not in used_addons]
                current_addons=split_keep_substring(getattr(preferences(),f'addons_to_exclude{get_active_space()}'))
                final_list=",".join(list(set(current_addons+addons_to_add)))
                setattr(preferences(),f'addons_to_exclude{get_active_space()}',final_list)
            else:
            
                setattr(preferences(),f'addons_to_exclude{get_active_space()}',(getattr(preferences(),f'addons_to_exclude{get_active_space()}')+","+self.my_enum) if getattr(preferences(),f'addons_to_exclude{get_active_space()}') else self.my_enum)
        savePreferences()
        return {'FINISHED'}
    def invoke(self, context, event):
        wm = context.window_manager
        context.scene.temp_collection.clear()
        addons=get_all_addons(self,context)
        self.addons=addons
        for a in addons:
            t=context.scene.temp_collection.add()
            t.name=a[1]
            t.icon='NONE'
            t.enabled=a[0] in split_keep_substring(getattr(preferences(),f'addons_to_exclude{get_active_space()}'))
        if not preferences().use_enum_search_for_popups:
            return wm.invoke_props_dialog(self,width=200*math.ceil(len(addons)/30))
        wm.invoke_search_popup(self)
        return {'FINISHED'}
class PAP_OT_searchPopupForDropDown(bpy.types.Operator):
    
    bl_idname = "cp.search_popup_for_dropdown"
    bl_label = "Add Panel"
    bl_property = "my_enum"
    category: bpy.props.StringProperty(default="Dropdown")
    my_enum: bpy.props.EnumProperty(name="Panel", description="", items=get_panel_categories)
    index: bpy.props.IntProperty(default=0)
    def draw(self,context):
        layout=self.layout
        grid=layout.grid_flow(columns=math.ceil(len(context.scene.temp_collection)/30))
        for t in context.scene.temp_collection:
            row=grid.row()
            row=row.split(factor=0.9)
            row.prop(t,'enabled',text=t.name)
            row.label(text='',icon=t.icon)
    def execute(self, context):
        index=self.index
        if not preferences().use_enum_search_for_popups:
            for a in context.scene.temp_collection:
                if not a.enabled:
                    preferences().dropdown_categories[index].panels=",".join([t for t in split_keep_substring(preferences().dropdown_categories[index].panels) if t!=a.name])
                    preferences().dropdown_categories[index].panels=",".join(split_keep_substring(preferences().dropdown_categories[index].panels))
            to_add=[]
            for a in context.scene.temp_collection:
                if a.enabled and a.name not in split_keep_substring(preferences().dropdown_categories[index].panels):
                    to_add.append(a.name)
            preferences().dropdown_categories[index].panels=",".join(split_keep_substring(preferences().dropdown_categories[index].panels)+to_add)
        else:
        #index=preferences().dropdown_categories.find(self.category)
            if index>=0:
                preferences().dropdown_categories[index].panels=(preferences().dropdown_categories[index].panels+","+self.my_enum) if preferences().dropdown_categories[index].panels else self.my_enum
        savePreferences()
        return {'FINISHED'}

    def invoke(self, context, event):
        wm = context.window_manager
        context.scene.temp_collection.clear()
        addons=get_panel_categories(self,context)
        self.addons=addons
        for a in addons:
            t=context.scene.temp_collection.add()
            t.name=a[0]
            t.icon=a[3]
            t.enabled=a[0] in split_keep_substring(preferences().dropdown_categories[self.index].panels)
        if not preferences().use_enum_search_for_popups:
            return wm.invoke_props_dialog(self,width=200*math.ceil(len(addons)/30))
        wm.invoke_search_popup(self)
        return {'FINISHED'}
class PAP_OT_searchPopupForFP(bpy.types.Operator):
    
    bl_idname = "cp.search_popup_for_fp"
    bl_label = "Add Panel"
    bl_property = "my_enum"
    category: bpy.props.StringProperty(default="FP")
    my_enum: bpy.props.EnumProperty(name="Panel", description="", items=get_panel_categories)
    index: bpy.props.IntProperty(default=0)
    def draw(self,context):
        layout=self.layout
        grid=layout.grid_flow(columns=math.ceil(len(context.scene.temp_collection)/30))
        for t in context.scene.temp_collection:
            row=grid.row()
            row=row.split(factor=0.9)
            row.prop(t,'enabled',text=t.name)
            row.label(text='',icon=t.icon)
    def execute(self, context):
        index=self.index
        if not preferences().use_enum_search_for_popups:
            for a in context.scene.temp_collection:
                if not a.enabled:
                    getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].panels=",".join([t for t in split_keep_substring(getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].panels) if t!=a.name])
                    getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].panels=",".join(split_keep_substring(getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].panels))
            to_add=[]
            for a in context.scene.temp_collection:
                if a.enabled and a.name not in split_keep_substring(getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].panels):
                    to_add.append(a.name)
            getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].panels=",".join(split_keep_substring(getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].panels)+to_add)
        else:
            #index=preferences().dropdown_categories.find(self.category)
            if index>=0:
                getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].panels=(getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].panels+","+self.my_enum) if getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].panels else self.my_enum
        savePreferences()
        return {'FINISHED'}

    def invoke(self, context, event):
        wm = context.window_manager
        context.scene.temp_collection.clear()
        addons=get_panel_categories(self,context)
        self.addons=addons
        for a in addons:
            t=context.scene.temp_collection.add()
            t.name=a[0]
            t.icon=a[3]
            t.enabled=a[0] in split_keep_substring(getattr(preferences(),f"focus_panel_categories{get_active_space()}")[self.index].panels)
        if not preferences().use_enum_search_for_popups:
            return wm.invoke_props_dialog(self,width=200*math.ceil(len(addons)/30))
        wm.invoke_search_popup(self)
        return {'FINISHED'}
class PAP_OT_Icon_Picker(bpy.types.Operator):
    
    bl_idname = "cp.change_icon"
    bl_label = "Icon"
    bl_description = "Change the icon displayed on the viewport and the pie menu"

    index: bpy.props.IntProperty(default=0)
    category: bpy.props.StringProperty(default="Pie")
    search: bpy.props.StringProperty(default="",options={'SKIP_SAVE'})
    #my_enum: bpy.props.EnumProperty(name="Panel", description="", items=get_icons)
    
    def draw(self, context):
        #self.layout.ui_units_x=
        self.layout.prop(self,'search',icon="VIEWZOOM",text="")
        grid=self.layout.grid_flow(columns=12,even_rows=True,even_columns=True,row_major=True)
        pcoll = icon_collection["icons"]
        custom_icons=pcoll.keys()
        blender_icons=ALL_ICONS
        for a in custom_icons:
            if self.search.lower() in a.lower():
                op=grid.operator("cp.set_icon",text="",icon_value=pcoll[a].icon_id,emboss=False)
                op.my_enum=a
                op.index=self.index
                op.category=self.category
        for a in blender_icons:
            if self.search.lower() in a.lower():
                op=grid.operator("cp.set_icon",text="",icon=a,emboss=False)
                op.my_enum=a
                op.index=self.index
                op.category=self.category
    def execute(self, context):
        return {'FINISHED'}
    def invoke(self, context, event):
        return context.window_manager.invoke_popup(self)
class PAP_OT_Change_Icon(bpy.types.Operator):
    bl_idname = "cp.set_icon"
    bl_label = "Icon"
    bl_description="Use this icon"
    bl_property = "my_enum"
    category: bpy.props.StringProperty(default="Pie")
    my_enum: bpy.props.StringProperty(default="NONE")
    index: bpy.props.IntProperty(default=0)
    def invoke(self, context,event):
        x,y=event.mouse_x,event.mouse_y
        context.window.cursor_warp(-10000,-10000)
        low_left_x=max(0,context.window.x)
        low_left_y=context.window.y
        reset_cursor=lambda : context.window.cursor_warp(x+(low_left_x),y+(low_left_y)-60)
        bpy.app.timers.register(reset_cursor,first_interval=0.00000001)
        index=self.index
        if index>=0:
            getattr(preferences(),f"workspace_categories{get_active_space()}")[index].icon=self.my_enum
            
        context.area.tag_redraw()
        savePreferences()
        return {'FINISHED'}

class PAP_OT_searchPopupForWorkspace(bpy.types.Operator):
    
    bl_idname = "cp.search_popup_for_workspace"
    bl_label = "Add Addon"
    bl_property = "my_enum"
    category: bpy.props.StringProperty(default="Workspace")
    my_enum: bpy.props.EnumProperty(name="Panel", description="", items=get_installed_addons)
    index: bpy.props.IntProperty(default=0)
    def draw(self,context):
        layout=self.layout
        grid=layout.grid_flow(columns=math.ceil(len(context.scene.temp_collection)/30))
        for t in context.scene.temp_collection:
            row=grid.row()
            row=row.split(factor=0.9)
            row.prop(t,'enabled',text=t.name)
            row.label(text='',icon=t.icon)
    def execute(self, context):
        space=get_active_space()
        index=self.index
        if not preferences().use_enum_search_for_popups:
            for a in context.scene.temp_collection:
                name=a.name
                if a.name in ["Tool(Tab)","View(Tab)","Node(Tab)","Options(Tab)"]:
                        name=name.replace("(Tab)","")
                
                if not a.enabled:
                    # print(",".join([t for t in split_keep_substring(getattr(preferences(),f'workspace_categories{space}')[index].panels) if t!=name]))
                    getattr(preferences(),f'workspace_categories{space}')[index].panels=",".join([t for t in split_keep_substring(getattr(preferences(),f'workspace_categories{space}')[index].panels) if t!=name])
                    
                    getattr(preferences(),f'workspace_categories{space}')[index].panels=",".join(split_keep_substring(getattr(preferences(),f'workspace_categories{space}')[index].panels))
            to_add=[]
            for a in context.scene.temp_collection:
                if a.enabled and a.name not in split_keep_substring(getattr(preferences(),f'workspace_categories{space}')[index].panels):
                    name=a.name
                    if a.name in ["Tool(Tab)","View(Tab)","Node(Tab)","Options(Tab)"]:
                            name=name.replace("(Tab)","")
                    to_add.append(name)
            
            getattr(preferences(),f'workspace_categories{space}')[index].panels=",".join(split_keep_substring(getattr(preferences(),f'workspace_categories{space}')[index].panels)+to_add)
        else:
            if index>=0:
                if self.my_enum=='All':
                    all_addons=",".join(get_installed_addon_names(self,context)+split_keep_substring(getattr(preferences(),f'workspace_categories{space}')[index].panels))

                    getattr(preferences(),f'workspace_categories{space}')[index].panels=all_addons
                elif self.my_enum=='Unfiltered':
                    used_addons=[]
                    for a in getattr(preferences(),f'workspace_categories{space}'):
                        used_addons.extend(split_keep_substring(a.panels))
                    all_addons=get_installed_addon_names(self,context)
                    addons_to_add=[b for b in all_addons if b not in used_addons]
                    current_addons=split_keep_substring(getattr(preferences(),f'workspace_categories{space}')[index].panels)
                    final_list=",".join(list(set(current_addons+addons_to_add)))
                    getattr(preferences(),f'workspace_categories{space}')[index].panels=final_list
                else:
                    getattr(preferences(),f'workspace_categories{space}')[index].panels=(getattr(preferences(),f'workspace_categories{space}')[index].panels+","+self.my_enum) if getattr(preferences(),f'workspace_categories{space}')[index].panels else self.my_enum
        savePreferences()
        return {'FINISHED'}

    def invoke(self, context, event):
        wm = context.window_manager
        context.scene.temp_collection.clear()
        addons=get_installed_addons(self,context)
        self.addons=addons
        for a in addons:
            if a[0] not in ('All','Unfiltered'):
                t=context.scene.temp_collection.add()
                t.name=a[1]
                t.icon=a[3]
                t.enabled=a[0] in split_keep_substring(getattr(preferences(),f'workspace_categories{get_active_space()}')[self.index].panels)
        if not preferences().use_enum_search_for_popups:
            return wm.invoke_props_dialog(self,width=200*math.ceil(len(addons)/30))
        wm.invoke_search_popup(self)
        return {'FINISHED'}
class PAP_OT_Search_Dropdown(bpy.types.Operator):
    
    bl_idname = "cp.search_dropdown"
    bl_label = "Search Dropdown"
    bl_description="Quickly search for any panel to display it as dropdown"
    bl_property = "my_enum"
    category: bpy.props.StringProperty(default="Workspace")
    my_enum: bpy.props.EnumProperty(name="Panel", description="", items=get_all_panel_categories)
    
    def execute(self, context):
        bpy.ops.cp.popupcompletepanel('INVOKE_DEFAULT',name=self.my_enum)
        return {'FINISHED'}

    def invoke(self, context, event):
        wm = context.window_manager
        wm.invoke_search_popup(self)
        return {'FINISHED'}


import inspect

class CP_OT_Load_Addons_List_For_Renaming(bpy.types.Operator):
    bl_idname = "cp.loadaddonsforrenaming"
    bl_label = "Load Addons"
    bl_description="Reload the list"
    bl_options = {'REGISTER', 'UNDO'}
    def execute(self, context):
        # preferences().addon_info_for_renaming.clear()
        load_renaming_list(context,space=preferences().space_type)
        return {'FINISHED'}
class CP_OT_Reset_Tab_Name(bpy.types.Operator):
    bl_idname = "cp.resettabname"
    bl_label = "Reset"
    bl_description="Reset to original Tab Name\nCTRL+LMB:Reset all"
    bl_options = {'REGISTER', 'UNDO'}
    def invoke(self, context,event):
        if event.ctrl:
            load_renaming_list(context,reset=True,space=get_active_space())
        else:
            base_type = bpy.types.Panel
            for typename in dir(bpy.types):
                
                try:
                    bl_type = getattr(bpy.types, typename,None)
                    if issubclass(bl_type, base_type):
                        if getattr(bl_type,'bl_category',None) and (getattr(bl_type,'backup_space','None')==preferences().space_type or getattr(bl_type,'bl_space_type','None')==preferences().space_type) :
                            
                            package_name=inspect.getmodule(bl_type).__package__ if inspect.getmodule(bl_type).__package__ else inspect.getmodule(bl_type).__name__
                            if "." in package_name:
                                name=package_name[:package_name.index(".")]
                            else:
                                name=package_name
                            if preferences().addon_info_for_renaming[preferences().addon_info_for_renaming_index].name==name:
                                preferences().addon_info_for_renaming[preferences().addon_info_for_renaming_index].tab_name=getattr(bl_type,'backup_category',preferences().addon_info_for_renaming[preferences().addon_info_for_renaming_index].tab_name)
                                break
                except:
                    pass
        return {'FINISHED'}
class CP_OT_Load_Addons_List(bpy.types.Operator):
    bl_idname = "cp.loadaddons"
    bl_label = "Load Addons"
    bl_description="Reload the list"
    bl_options = {'REGISTER', 'UNDO'}
    def execute(self, context):
        load_reordering_list(context,space=preferences().space_type)
        return {'FINISHED'}
class CP_OT_Open_Preferences(bpy.types.Operator):
    bl_idname = "cp.openpreferences"
    bl_label = "Open Addon Preferences"
    bl_description="Open Addon Preferences"
    bl_options = {'REGISTER', 'UNDO'}
    def invoke(self, context,event):
        render = bpy.context.scene.render
        prefs = bpy.context.preferences
        view = prefs.view
        orgResX = render.resolution_x
        orgResY = render.resolution_y
        w=3000
        h=2000
        render.resolution_x = int(w*2/3)
        render.resolution_y = int(h*2/3)
        orgDispMode = view.render_display_type
        view.render_display_type = "WINDOW"
        bpy.ops.render.view_show("INVOKE_DEFAULT")
        area = bpy.context.window_manager.windows[-1].screen.areas[0]
        area.type = "PREFERENCES"
        view.render_display_type = orgDispMode
        render.resolution_x = orgResX
        render.resolution_y = orgResY
        bpy.context.preferences.active_section = 'ADDONS'
        bpy.data.window_managers["WinMan"].addon_search = "CleanPanels"
        return {'FINISHED'}
class CP_OT_Inject_Tracking_Code(bpy.types.Operator):
    bl_idname = "cp.injecttrackingcode"
    bl_label = "Click this button for proper ordering of Sub-Panels"
    bl_description="Pressing this button will insert a few lines of code in the utils module of blender which will enable Clean Panels to work correctly"
    bl_options = {'REGISTER', 'UNDO'}
    def invoke(self, context,event):
        
        version=bpy.app.version
        if sys.platform=='darwin':
            util_file_path=os.path.join(os.path.dirname(os.path.dirname(bpy.app.binary_path)),'Resources',f"{version[0]}.{version[1]}","scripts","modules","bpy","utils","__init__.py")
        else:
            util_file_path=os.path.join(os.path.dirname(bpy.app.binary_path),f"{version[0]}.{version[1]}","scripts","modules","bpy","utils","__init__.py")
        try:
            inject_tracking_code(util_file_path)
            savePreferences()
        except Exception as e:
            self.report({'WARNING'},'Please start blender as administrator/superuser (Only required Once)')
            print("Error:",e)
        return {'FINISHED'}
class CP_OT_Inject_Code(bpy.types.Operator):
    bl_idname = "cp.injectcode"
    bl_label = "Enable Ordering"
    bl_description="Pressing this button will insert a few lines of code in the addon_utils module of blender which will enable Clean Panels to work correctly"
    bl_options = {'REGISTER', 'UNDO'}
    @classmethod
    def poll(cls,context):
        return not preferences().injected_code
    def invoke(self, context,event):
        
        version=bpy.app.version
        if sys.platform=='darwin':
            util_file_path=os.path.join(os.path.dirname(os.path.dirname(bpy.app.binary_path)),'Resources',f"{version[0]}.{version[1]}","scripts","modules","addon_utils.py")
        else:
            util_file_path=os.path.join(os.path.dirname(bpy.app.binary_path),f"{version[0]}.{version[1]}","scripts","modules","addon_utils.py")
        try:
            inject_code(util_file_path)
            preferences().injected_code=True
            savePreferences()
        except Exception as e:
            self.report({'WARNING'},'Please start blender as administrator/superuser (Only required Once)')
            print("Error:",e)
        return {'FINISHED'}
class CP_OT_Inject_Delayed_Start_Code(bpy.types.Operator):
    bl_idname = "cp.enabledelayedloading"
    bl_label = "Enable Delayed Addon Loading"
    bl_description="Pressing this button will insert a few lines of code in the addon_utils file of blender which will enable Clean Panels to delay the loading of other addons on boot"
    bl_options = {'REGISTER', 'UNDO'}
    @classmethod
    def poll(cls,context):
        if bpy.app.version>=(3,6,0):
            return True
        cls.poll_message_set("Please upgrade your blender version to 4.0.0 or higher")
        return False
    def invoke(self, context,event):
        
        version=bpy.app.version
        if sys.platform=='darwin':
            util_file_path=os.path.join(os.path.dirname(os.path.dirname(bpy.app.binary_path)),'Resources',f"{version[0]}.{version[1]}","scripts","modules","addon_utils.py")
        else:
            util_file_path=os.path.join(os.path.dirname(bpy.app.binary_path),f"{version[0]}.{version[1]}","scripts","modules","addon_utils.py")
        try:
            if check_if_old_injection_exists(util_file_path,"atl_file"):
                remove_delayed_load_code(util_file_path)
                preferences().delayed_loading_code_injected=False
            else:
                inject_delayed_load_code(util_file_path)
                preferences().delayed_loading_code_injected=True
            savePreferences()
        except Exception as e:
            self.report({'WARNING'},'Please start blender as administrator/superuser (Only required Once)')
            print("Error:",e)
        return {'FINISHED'}
class CP_OT_Save_Config(bpy.types.Operator):
    bl_idname = "cp.saveconfig"
    bl_label = "Save Config"
    bl_description="Save Clean Panels Configuration"
    bl_options = {'REGISTER', 'UNDO'}
    def execute(self, context):
        savePreferences()
        self.report({'INFO'},'Configuration Saved!')
        return {'FINISHED'}
class CP_OT_Reset_Config(bpy.types.Operator,ExportHelper):
    bl_idname = "cp.resetconfig"
    bl_label = "Reset Config"
    bl_description="Reset all Clean Panels Settings"
    bl_options = {'REGISTER', 'UNDO'}
    filepath: bpy.props.StringProperty(
        name="File Path",
        description="Filepath used for exporting the file",
        subtype='FILE_PATH',
    )
    filename_ext:bpy.props.StringProperty(default=".txt",options={'SKIP_SAVE','HIDDEN'})
    def execute(self, context):
        reset_preferences()
        savePreferences()
            
        return {'FINISHED'}
    def invoke(self, context: Context, event: Event):
        return context.window_manager.invoke_confirm(self,event)
class CP_OT_Export_Config(bpy.types.Operator,ExportHelper):
    bl_idname = "cp.exportconfig"
    bl_label = "Export Config"
    bl_description="Export Config File"
    bl_options = {'REGISTER', 'UNDO'}
    filepath: bpy.props.StringProperty(
        name="File Path",
        description="Filepath used for exporting the file",
        subtype='FILE_PATH',
    )
    filename_ext:bpy.props.StringProperty(default=".txt",options={'SKIP_SAVE','HIDDEN'})
    def execute(self, context):
        savePreferences()
        path=os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))), "config", "CP-config.txt")
        if os.path.isfile(path):
            shutil.copy(path,self.filepath)
        return {'FINISHED'}
class CP_OT_Import_Config(bpy.types.Operator,ImportHelper):
    bl_idname = "cp.importconfig"
    bl_label = "Import Config"
    bl_description="Import Config File"
    bl_options = {'REGISTER', 'UNDO'}
    filename_ext = '.txt'
    directory:bpy.props.StringProperty()
    filter_glob: bpy.props.StringProperty(
        default='*.txt',
        options={'HIDDEN'}
    )
    def execute(self, context):
        path=os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))), "config", "CP-config.txt")
        if os.path.isfile(self.filepath):
            data=None
            with open(self.filepath,mode='r',encoding='utf8',newline='\n') as f:
                data=f.readlines()
            if data:
                with open(path,mode='w',encoding='utf8',newline='\n') as f:
                    f.writelines(data)
        loadPreferences()
        return {'FINISHED'}
class CP_OT_Clear_Order(bpy.types.Operator):
    bl_idname = "cp.clearforcedorders"
    bl_label = "Clear Forced Order (Experimental)"
    bl_description="Clear Forced N-Panel orders\nCTRL+LMB:Reset"
    bl_options = {'REGISTER', 'UNDO'}
    # @classmethod
    # def poll(cls,context):
    #     return preferences().addon_info and getattr(preferences(),f"addon_info{get_active_space()}")[getattr(preferences(),f"addon_info{get_active_space()}_index")] and getattr(preferences(),f"addon_info{get_active_space()}")[getattr(preferences(),f"addon_info{get_active_space()}_index")].ordered
    def invoke(self, context,event):
        if event.ctrl:
            clean_all_python_files(remove=True)
        else:
            if preferences().addon_info and getattr(preferences(),f"addon_info{get_active_space()}")[getattr(preferences(),f"addon_info{get_active_space()}_index")] and getattr(preferences(),f"addon_info{get_active_space()}")[getattr(preferences(),f"addon_info{get_active_space()}_index")].ordered:
                clean_all_python_files(remove=False)
                
                
        #reorder_addons(None)
        savePreferences()
        return {'FINISHED'}
class CP_OT_Change_Category(bpy.types.Operator):
    bl_idname = "cp.changecategory"
    bl_label = "Update Category in source file"
    bl_options = {'REGISTER', 'UNDO'}
    @classmethod
    def description(self, context,properties):
        if preferences().filtering_method=="Use N-Panel Filtering":
            return "Confirm New Tab Names"
        else:
            return "Set new Tab(This will edit the python files of the addon and replace the panel names with the new name)\nCTRL+LMB:Reset\nSHIFT+LMB:Set for All"
    # @classmethod
    # def poll(cls,context):
    #     return preferences().addon_info and preferences().addon_info[getattr(preferences(),f"addon_info{get_active_space()}_index")] and preferences().addon_info[getattr(preferences(),f"addon_info{get_active_space()}_index")].ordered
    def invoke(self, context,event):
        if not preferences().filtering_method=="Use N-Panel Filtering":
            if event.ctrl:
                if event.shift:
                    for i in range(len(preferences().addon_info_for_renaming)):
                        change_category(i,True)   
                else:
                    change_category(preferences().addon_info_for_renaming_index,True)
            else:
                if event.shift:
                    for i in range(len(preferences().addon_info_for_renaming)):
                        change_category(i,False)   
                else:
                    change_category(preferences().addon_info_for_renaming_index,False)  
        else:
            workspace_category_enabled(preferences().categories,context)                
        #reorder_addons(None)
        savePreferences()
        return {'FINISHED'}
class CP_OT_Move_Category(bpy.types.Operator):
    bl_idname = "cp.movecategory"
    bl_label = ""
    bl_description=""
    bl_options = {'REGISTER', 'UNDO'}
    direction: bpy.props.StringProperty(default="UP",options={'SKIP_SAVE','HIDDEN'})
    index: bpy.props.IntProperty()
    category: bpy.props.StringProperty()
    @classmethod
    def description(cls,context,properties):
        if properties.direction=='UP':
            return "Move Up\nCTRL+LMB:Move to Top"
        else:
            return "Move Down\nCTRL+LMB:Move to Bottom"
    def invoke(self, context,event):
        if self.direction=='UP':
            if self.index==0:
                return {'CANCELLED'}
        else:
            if self.category=='Pie':
                if self.index+1>=len(preferences().panel_categories):
                    return {'CANCELLED'}
            elif self.category=='DropDown':
                if self.index+1>=len(preferences().dropdown_categories):
                    return {'CANCELLED'}
            elif self.category=='FP':
                if self.index+1>=len(getattr(preferences(),f"focus_panel_categories{get_active_space()}")):
                    return {'CANCELLED'}
            else:
                if self.index+1>=len(getattr(preferences(),f"workspace_categories{get_active_space()}")):
                    return {'CANCELLED'}
        if self.category=='Pie':
             
            
            if self.direction=='UP':
                for index in range(self.index,0 if event.ctrl else self.index-1,-1):
                    temp_name=preferences().panel_categories[index-1].name
                    temp_panels=preferences().panel_categories[index-1].panels
                    preferences().panel_categories[index-1].name=preferences().panel_categories[index].name
                    preferences().panel_categories[index-1].panels=preferences().panel_categories[index].panels
                    preferences().panel_categories[index].name=temp_name
                    preferences().panel_categories[index].panels=temp_panels
            else:
                for index in range(self.index,len(preferences().panel_categories)-1 if event.ctrl else self.index+1):
                    temp_name=preferences().panel_categories[index+1].name
                    temp_panels=preferences().panel_categories[index+1].panels
                    preferences().panel_categories[index+1].name=preferences().panel_categories[index].name
                    preferences().panel_categories[index+1].panels=preferences().panel_categories[index].panels
                    preferences().panel_categories[index].name=temp_name
                    preferences().panel_categories[index].panels=temp_panels
        elif self.category=='DropDown':
            if self.direction=='UP':
                for index in range(self.index,0 if event.ctrl else self.index-1,-1):
                    temp_name=preferences().dropdown_categories[index-1].name
                    temp_panels=preferences().dropdown_categories[index-1].panels
                    preferences().dropdown_categories[index-1].name=preferences().dropdown_categories[index].name
                    preferences().dropdown_categories[index-1].panels=preferences().dropdown_categories[index].panels
                    preferences().dropdown_categories[index].name=temp_name
                    preferences().dropdown_categories[index].panels=temp_panels
            else:
                for index in range(self.index,len(preferences().dropdown_categories)-1 if event.ctrl else self.index+1):
                    temp_name=preferences().dropdown_categories[index+1].name
                    temp_panels=preferences().dropdown_categories[index+1].panels
                    preferences().dropdown_categories[index+1].name=preferences().dropdown_categories[index].name
                    preferences().dropdown_categories[index+1].panels=preferences().dropdown_categories[index].panels
                    preferences().dropdown_categories[index].name=temp_name
                    preferences().dropdown_categories[index].panels=temp_panels
        elif self.category=='FP':
            if self.direction=='UP':
                for index in range(self.index,0 if event.ctrl else self.index-1,-1):
                    temp_name=getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index-1].name
                    temp_panels=getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index-1].panels
                    getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index-1].name=getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].name
                    getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index-1].panels=getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].panels
                    getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].name=temp_name
                    getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].panels=temp_panels
            else:
                for index in range(self.index,len(getattr(preferences(),f"focus_panel_categories{get_active_space()}"))-1 if event.ctrl else self.index+1):
                    temp_name=getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index+1].name
                    temp_panels=getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index+1].panels
                    getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index+1].name=getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].name
                    getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index+1].panels=getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].panels
                    getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].name=temp_name
                    getattr(preferences(),f"focus_panel_categories{get_active_space()}")[index].panels=temp_panels
        else:
            if self.direction=='UP':
                for index in range(self.index,0 if event.ctrl else self.index-1,-1):
                    temp_name=getattr(preferences(),f"workspace_categories{get_active_space()}")[index-1].name
                    temp_panels=getattr(preferences(),f"workspace_categories{get_active_space()}")[index-1].panels
                    temp_icon=getattr(preferences(),f"workspace_categories{get_active_space()}")[index-1].icon
                    getattr(preferences(),f"workspace_categories{get_active_space()}")[index-1].name=getattr(preferences(),f"workspace_categories{get_active_space()}")[index].name
                    getattr(preferences(),f"workspace_categories{get_active_space()}")[index-1].panels=getattr(preferences(),f"workspace_categories{get_active_space()}")[index].panels
                    getattr(preferences(),f"workspace_categories{get_active_space()}")[index-1].icon=getattr(preferences(),f"workspace_categories{get_active_space()}")[index].icon
                    getattr(preferences(),f"workspace_categories{get_active_space()}")[index].name=temp_name
                    getattr(preferences(),f"workspace_categories{get_active_space()}")[index].panels=temp_panels
                    getattr(preferences(),f"workspace_categories{get_active_space()}")[index].icon=temp_icon
            else:
                for index in range(self.index,len(getattr(preferences(),f"workspace_categories{get_active_space()}"))-1 if event.ctrl else self.index+1):
                    temp_name=getattr(preferences(),f"workspace_categories{get_active_space()}")[index+1].name
                    temp_panels=getattr(preferences(),f"workspace_categories{get_active_space()}")[index+1].panels
                    temp_icon=getattr(preferences(),f"workspace_categories{get_active_space()}")[index+1].icon
                    getattr(preferences(),f"workspace_categories{get_active_space()}")[index+1].name=getattr(preferences(),f"workspace_categories{get_active_space()}")[index].name
                    getattr(preferences(),f"workspace_categories{get_active_space()}")[index+1].panels=getattr(preferences(),f"workspace_categories{get_active_space()}")[index].panels
                    getattr(preferences(),f"workspace_categories{get_active_space()}")[index+1].icon=getattr(preferences(),f"workspace_categories{get_active_space()}")[index].icon
                    getattr(preferences(),f"workspace_categories{get_active_space()}")[index].name=temp_name
                    getattr(preferences(),f"workspace_categories{get_active_space()}")[index].panels=temp_panels
                    getattr(preferences(),f"workspace_categories{get_active_space()}")[index].icon=temp_icon
        savePreferences()
        return {'FINISHED'}
class CP_OT_Move_Addon_In_Category(bpy.types.Operator):
    bl_idname = "cp.moveaddonincategory"
    bl_label = "Move"
    bl_description=""
    bl_options = {'REGISTER', 'UNDO'}
    direction: bpy.props.StringProperty(default="UP",options={'SKIP_SAVE','HIDDEN'})
    
    def invoke(self, context,event):
        scene= context.scene
        
        index=scene.addon_info_index
        if self.direction=='UP':
            if scene.addon_info_index>0:
                temp_name=scene.addon_info[index-1].name
                temp_addons=scene.addon_info[index-1].addons
                temp_ordered=scene.addon_info[index-1].ordered
                scene.addon_info[index-1].name=scene.addon_info[index].name
                scene.addon_info[index-1].addons=scene.addon_info[index].addons
                scene.addon_info[index-1].ordered=scene.addon_info[index].ordered
                scene.addon_info[index].name=temp_name
                scene.addon_info[index].addons=temp_addons
                scene.addon_info[index].ordered=temp_ordered
                scene.addon_info_index-=1
        else:
            if scene.addon_info_index<len(scene.addon_info)-1:
                temp_name=scene.addon_info[index+1].name
                temp_addons=scene.addon_info[index+1].addons
                temp_ordered=scene.addon_info[index+1].ordered
                scene.addon_info[index+1].name=scene.addon_info[index].name
                scene.addon_info[index+1].addons=scene.addon_info[index].addons
                scene.addon_info[index+1].ordered=scene.addon_info[index].ordered
                scene.addon_info[index].name=temp_name
                scene.addon_info[index].addons=temp_addons
                scene.addon_info[index].ordered=temp_ordered
                scene.addon_info_index+=1
        savePreferences()
        return {'FINISHED'}
class CP_OT_Move_Addon(bpy.types.Operator):
    bl_idname = "cp.moveaddon"
    bl_label = "Move"
    bl_description=""
    bl_options = {'REGISTER', 'UNDO'}
    direction: bpy.props.StringProperty(default="UP",options={'SKIP_SAVE','HIDDEN'})
    
    def invoke(self, context,event):
        index=getattr(preferences(),f"addon_info{get_active_space()}_index")
        if self.direction=='UP':
            if getattr(preferences(),f"addon_info{get_active_space()}_index")>0:
                temp_name=getattr(preferences(),f"addon_info{get_active_space()}")[index-1].name
                temp_addons=getattr(preferences(),f"addon_info{get_active_space()}")[index-1].addons
                temp_ordered=getattr(preferences(),f"addon_info{get_active_space()}")[index-1].ordered
                getattr(preferences(),f"addon_info{get_active_space()}")[index-1].name=getattr(preferences(),f"addon_info{get_active_space()}")[index].name
                getattr(preferences(),f"addon_info{get_active_space()}")[index-1].addons=getattr(preferences(),f"addon_info{get_active_space()}")[index].addons
                getattr(preferences(),f"addon_info{get_active_space()}")[index-1].ordered=getattr(preferences(),f"addon_info{get_active_space()}")[index].ordered
                getattr(preferences(),f"addon_info{get_active_space()}")[index].name=temp_name
                getattr(preferences(),f"addon_info{get_active_space()}")[index].addons=temp_addons
                getattr(preferences(),f"addon_info{get_active_space()}")[index].ordered=temp_ordered
                setattr(preferences(),f"addon_info{get_active_space()}_index",getattr(preferences(),f"addon_info{get_active_space()}_index")-1)
        else:
            if getattr(preferences(),f"addon_info{get_active_space()}_index")<len(preferences().addon_info)-1:
                temp_name=getattr(preferences(),f"addon_info{get_active_space()}")[index+1].name
                temp_addons=getattr(preferences(),f"addon_info{get_active_space()}")[index+1].addons
                temp_ordered=getattr(preferences(),f"addon_info{get_active_space()}")[index+1].ordered
                getattr(preferences(),f"addon_info{get_active_space()}")[index+1].name=getattr(preferences(),f"addon_info{get_active_space()}")[index].name
                getattr(preferences(),f"addon_info{get_active_space()}")[index+1].addons=getattr(preferences(),f"addon_info{get_active_space()}")[index].addons
                getattr(preferences(),f"addon_info{get_active_space()}")[index+1].ordered=getattr(preferences(),f"addon_info{get_active_space()}")[index].ordered
                getattr(preferences(),f"addon_info{get_active_space()}")[index].name=temp_name
                getattr(preferences(),f"addon_info{get_active_space()}")[index].addons=temp_addons
                getattr(preferences(),f"addon_info{get_active_space()}")[index].ordered=temp_ordered
                setattr(preferences(),f"addon_info{get_active_space()}_index",getattr(preferences(),f"addon_info{get_active_space()}_index")+1)
        savePreferences()
        return {'FINISHED'}
class CP_Panel_Category(PropertyGroup):
    #enabled: bpy.props.BoolProperty(default=False,update=workspace_category_enabled)
    icon: bpy.props.StringProperty(default="COLLAPSEMENU",update=savePreferences)
    panels: bpy.props.StringProperty(default="",name="Panels",update=savePreferences)
    name: bpy.props.StringProperty(default="Category",name="Name",update=savePreferences)



    #change_category(preferences().addon_info_for_renaming_index)

class Category_Indices(PropertyGroup):
    filter_enabled: bpy.props.BoolProperty(default=False,update=workspace_category_enabled,name="Filter")
    filter_enabled_node_editor: bpy.props.BoolProperty(default=False,update=workspace_category_enabled,name="Filter")
    filter_enabled_image_editor: bpy.props.BoolProperty(default=False,update=workspace_category_enabled,name="Filter")
    enabled_0: bpy.props.BoolProperty(default=False)
    enabled_1: bpy.props.BoolProperty(default=False)
    enabled_2: bpy.props.BoolProperty(default=False)
    enabled_3: bpy.props.BoolProperty(default=False)
    enabled_4: bpy.props.BoolProperty(default=False)
    enabled_5: bpy.props.BoolProperty(default=False)
    enabled_6: bpy.props.BoolProperty(default=False)
    enabled_7: bpy.props.BoolProperty(default=False)
    enabled_8: bpy.props.BoolProperty(default=False)
    enabled_9: bpy.props.BoolProperty(default=False)
    enabled_10: bpy.props.BoolProperty(default=False)
    enabled_11: bpy.props.BoolProperty(default=False)
    enabled_12: bpy.props.BoolProperty(default=False)
    enabled_13: bpy.props.BoolProperty(default=False)
    enabled_14: bpy.props.BoolProperty(default=False)
    enabled_15: bpy.props.BoolProperty(default=False)
    enabled_16: bpy.props.BoolProperty(default=False)
    enabled_17: bpy.props.BoolProperty(default=False)
    enabled_18: bpy.props.BoolProperty(default=False)
    enabled_19: bpy.props.BoolProperty(default=False)
    enabled_20: bpy.props.BoolProperty(default=False)
    enabled_21: bpy.props.BoolProperty(default=False)
    enabled_22: bpy.props.BoolProperty(default=False)
    enabled_23: bpy.props.BoolProperty(default=False)
    enabled_24: bpy.props.BoolProperty(default=False)
    enabled_25: bpy.props.BoolProperty(default=False)
    enabled_26: bpy.props.BoolProperty(default=False)
    enabled_27: bpy.props.BoolProperty(default=False)
    enabled_28: bpy.props.BoolProperty(default=False)
    enabled_29: bpy.props.BoolProperty(default=False)
    enabled_30: bpy.props.BoolProperty(default=False)
    enabled_31: bpy.props.BoolProperty(default=False)
    enabled_32: bpy.props.BoolProperty(default=False)
    enabled_33: bpy.props.BoolProperty(default=False)
    enabled_34: bpy.props.BoolProperty(default=False)
    enabled_35: bpy.props.BoolProperty(default=False)
    enabled_36: bpy.props.BoolProperty(default=False)
    enabled_37: bpy.props.BoolProperty(default=False)
    enabled_38: bpy.props.BoolProperty(default=False)
    enabled_39: bpy.props.BoolProperty(default=False)
    enabled_40: bpy.props.BoolProperty(default=False)
    enabled_41: bpy.props.BoolProperty(default=False)
    enabled_42: bpy.props.BoolProperty(default=False)
    enabled_43: bpy.props.BoolProperty(default=False)
    enabled_44: bpy.props.BoolProperty(default=False)
    enabled_45: bpy.props.BoolProperty(default=False)
    enabled_46: bpy.props.BoolProperty(default=False)
    enabled_47: bpy.props.BoolProperty(default=False)
    enabled_48: bpy.props.BoolProperty(default=False)
    enabled_49: bpy.props.BoolProperty(default=False)
    enabled_node_editor_0: bpy.props.BoolProperty(default=False)
    enabled_node_editor_1: bpy.props.BoolProperty(default=False)
    enabled_node_editor_2: bpy.props.BoolProperty(default=False)
    enabled_node_editor_3: bpy.props.BoolProperty(default=False)
    enabled_node_editor_4: bpy.props.BoolProperty(default=False)
    enabled_node_editor_5: bpy.props.BoolProperty(default=False)
    enabled_node_editor_6: bpy.props.BoolProperty(default=False)
    enabled_node_editor_7: bpy.props.BoolProperty(default=False)
    enabled_node_editor_8: bpy.props.BoolProperty(default=False)
    enabled_node_editor_9: bpy.props.BoolProperty(default=False)
    enabled_node_editor_10: bpy.props.BoolProperty(default=False)
    enabled_node_editor_11: bpy.props.BoolProperty(default=False)
    enabled_node_editor_12: bpy.props.BoolProperty(default=False)
    enabled_node_editor_13: bpy.props.BoolProperty(default=False)
    enabled_node_editor_14: bpy.props.BoolProperty(default=False)
    enabled_node_editor_15: bpy.props.BoolProperty(default=False)
    enabled_node_editor_16: bpy.props.BoolProperty(default=False)
    enabled_node_editor_17: bpy.props.BoolProperty(default=False)
    enabled_node_editor_18: bpy.props.BoolProperty(default=False)
    enabled_node_editor_19: bpy.props.BoolProperty(default=False)
    enabled_node_editor_20: bpy.props.BoolProperty(default=False)
    enabled_node_editor_21: bpy.props.BoolProperty(default=False)
    enabled_node_editor_22: bpy.props.BoolProperty(default=False)
    enabled_node_editor_23: bpy.props.BoolProperty(default=False)
    enabled_node_editor_24: bpy.props.BoolProperty(default=False)
    enabled_node_editor_25: bpy.props.BoolProperty(default=False)
    enabled_node_editor_26: bpy.props.BoolProperty(default=False)
    enabled_node_editor_27: bpy.props.BoolProperty(default=False)
    enabled_node_editor_28: bpy.props.BoolProperty(default=False)
    enabled_node_editor_29: bpy.props.BoolProperty(default=False)
    enabled_node_editor_30: bpy.props.BoolProperty(default=False)
    enabled_node_editor_31: bpy.props.BoolProperty(default=False)
    enabled_node_editor_32: bpy.props.BoolProperty(default=False)
    enabled_node_editor_33: bpy.props.BoolProperty(default=False)
    enabled_node_editor_34: bpy.props.BoolProperty(default=False)
    enabled_node_editor_35: bpy.props.BoolProperty(default=False)
    enabled_node_editor_36: bpy.props.BoolProperty(default=False)
    enabled_node_editor_37: bpy.props.BoolProperty(default=False)
    enabled_node_editor_38: bpy.props.BoolProperty(default=False)
    enabled_node_editor_39: bpy.props.BoolProperty(default=False)
    enabled_node_editor_40: bpy.props.BoolProperty(default=False)
    enabled_node_editor_41: bpy.props.BoolProperty(default=False)
    enabled_node_editor_42: bpy.props.BoolProperty(default=False)
    enabled_node_editor_43: bpy.props.BoolProperty(default=False)
    enabled_node_editor_44: bpy.props.BoolProperty(default=False)
    enabled_node_editor_45: bpy.props.BoolProperty(default=False)
    enabled_node_editor_46: bpy.props.BoolProperty(default=False)
    enabled_node_editor_47: bpy.props.BoolProperty(default=False)
    enabled_node_editor_48: bpy.props.BoolProperty(default=False)
    enabled_node_editor_49: bpy.props.BoolProperty(default=False)
    enabled_image_editor_0: bpy.props.BoolProperty(default=False)
    enabled_image_editor_1: bpy.props.BoolProperty(default=False)
    enabled_image_editor_2: bpy.props.BoolProperty(default=False)
    enabled_image_editor_3: bpy.props.BoolProperty(default=False)
    enabled_image_editor_4: bpy.props.BoolProperty(default=False)
    enabled_image_editor_5: bpy.props.BoolProperty(default=False)
    enabled_image_editor_6: bpy.props.BoolProperty(default=False)
    enabled_image_editor_7: bpy.props.BoolProperty(default=False)
    enabled_image_editor_8: bpy.props.BoolProperty(default=False)
    enabled_image_editor_9: bpy.props.BoolProperty(default=False)
    enabled_image_editor_10: bpy.props.BoolProperty(default=False)
    enabled_image_editor_11: bpy.props.BoolProperty(default=False)
    enabled_image_editor_12: bpy.props.BoolProperty(default=False)
    enabled_image_editor_13: bpy.props.BoolProperty(default=False)
    enabled_image_editor_14: bpy.props.BoolProperty(default=False)
    enabled_image_editor_15: bpy.props.BoolProperty(default=False)
    enabled_image_editor_16: bpy.props.BoolProperty(default=False)
    enabled_image_editor_17: bpy.props.BoolProperty(default=False)
    enabled_image_editor_18: bpy.props.BoolProperty(default=False)
    enabled_image_editor_19: bpy.props.BoolProperty(default=False)
    enabled_image_editor_20: bpy.props.BoolProperty(default=False)
    enabled_image_editor_21: bpy.props.BoolProperty(default=False)
    enabled_image_editor_22: bpy.props.BoolProperty(default=False)
    enabled_image_editor_23: bpy.props.BoolProperty(default=False)
    enabled_image_editor_24: bpy.props.BoolProperty(default=False)
    enabled_image_editor_25: bpy.props.BoolProperty(default=False)
    enabled_image_editor_26: bpy.props.BoolProperty(default=False)
    enabled_image_editor_27: bpy.props.BoolProperty(default=False)
    enabled_image_editor_28: bpy.props.BoolProperty(default=False)
    enabled_image_editor_29: bpy.props.BoolProperty(default=False)
    enabled_image_editor_30: bpy.props.BoolProperty(default=False)
    enabled_image_editor_31: bpy.props.BoolProperty(default=False)
    enabled_image_editor_32: bpy.props.BoolProperty(default=False)
    enabled_image_editor_33: bpy.props.BoolProperty(default=False)
    enabled_image_editor_34: bpy.props.BoolProperty(default=False)
    enabled_image_editor_35: bpy.props.BoolProperty(default=False)
    enabled_image_editor_36: bpy.props.BoolProperty(default=False)
    enabled_image_editor_37: bpy.props.BoolProperty(default=False)
    enabled_image_editor_38: bpy.props.BoolProperty(default=False)
    enabled_image_editor_39: bpy.props.BoolProperty(default=False)
    enabled_image_editor_40: bpy.props.BoolProperty(default=False)
    enabled_image_editor_41: bpy.props.BoolProperty(default=False)
    enabled_image_editor_42: bpy.props.BoolProperty(default=False)
    enabled_image_editor_43: bpy.props.BoolProperty(default=False)
    enabled_image_editor_44: bpy.props.BoolProperty(default=False)
    enabled_image_editor_45: bpy.props.BoolProperty(default=False)
    enabled_image_editor_46: bpy.props.BoolProperty(default=False)
    enabled_image_editor_47: bpy.props.BoolProperty(default=False)
    enabled_image_editor_48: bpy.props.BoolProperty(default=False)
    enabled_image_editor_49: bpy.props.BoolProperty(default=False)
def reload_icons(self, context):
    savePreferences()
    load_icons(only_custom=True)
def remove_holder_tab_update(self,context):
    if not self.remove_holder_tab:
        if not self.holder_tab_name:
            self.holder_tab_name='DUMP'
class PAPPrefs(bpy.types.AddonPreferences):
    bl_idname = __package__
    use_enum_search_for_popups:bpy.props.BoolProperty(default=False,name='Use Search instead of Popup for adding Panels/Addons to categories')
    auto_backup_addons: bpy.props.BoolProperty(default=False,name="Automatically Backup addons before making changes",description=f"Create automatic backups while editing the addon files (for N-Panel renaming and clearing forced orders)\n Stored at: {os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(__file__))),'Addon-Backups-CleanPanels')}")
    show_panel_pies: bpy.props.BoolProperty(default=False, name="Panels and Pies")
    pop_out_style:bpy.props.EnumProperty(items=(("Pie-PopUp","Pie-PopUp","Pie-PopUp"),("DropDown","DropDown","DropDown")),default=0,name="PopUp Panel Style",update=savePreferences)
    panel_categories : bpy.props.CollectionProperty(type=CP_Panel_Category)
    dropdown_categories : bpy.props.CollectionProperty(type=CP_Panel_Category)
    workspace_categories: bpy.props.CollectionProperty(type=CP_Panel_Category)
    focus_panel_categories : bpy.props.CollectionProperty(type=CP_Panel_Category)
    workspace_categories_image_editor: bpy.props.CollectionProperty(type=CP_Panel_Category)
    focus_panel_categories_image_editor : bpy.props.CollectionProperty(type=CP_Panel_Category)
    workspace_categories_node_editor: bpy.props.CollectionProperty(type=CP_Panel_Category)
    focus_panel_categories_node_editor : bpy.props.CollectionProperty(type=CP_Panel_Category)
    show_panel_categories: bpy.props.BoolProperty(default=False,name="Pie Panels")
    show_dropdown_categories: bpy.props.BoolProperty(default=False,name="Dropdown Panels")
    show_workspace_categories: bpy.props.BoolProperty(default=False, name="Workspace Addon Categories")
    show_npanel_ordering: bpy.props.BoolProperty(default=False,name="N-Panel ReOrdering")
    show_npanel_renaming: bpy.props.BoolProperty(default=False,name="N-Panel Renaming")
    show_focus_panel_categories:bpy.props.BoolProperty(default=False,name="Focus Panel Categories")
    draw_side: bpy.props.EnumProperty(name="Direction",items=(("LEFT",'Left','Left'),("RIGHT",'Right','Right')),update=draw_side_changed)
    addons_to_exclude: bpy.props.StringProperty(default="",name="Addons To Exclude (Will always be available)",update=exclusion_list_changed)
    addons_to_exclude_node_editor: bpy.props.StringProperty(default="",name="Addons To Exclude (Will always be available)",update=exclusion_list_changed)
    addons_to_exclude_image_editor: bpy.props.StringProperty(default="",name="Addons To Exclude (Will always be available)",update=exclusion_list_changed)
    experimental:bpy.props.BoolProperty(default=False,name="Experimental Features",update=savePreferences)
    use_sticky_popup: bpy.props.BoolProperty(default=True,name="Use Sticky Popups",update=savePreferences)
    addon_info:bpy.props.CollectionProperty(type=AddonInfo)
    addon_info_for_renaming:bpy.props.CollectionProperty(type=AddonInfoRename)
    addon_info_index: bpy.props.IntProperty(default=0,name="Selected Tab")
    addon_info_for_renaming_index: bpy.props.IntProperty(default=0,name="Selected Addon")
    addon_info_image_editor:bpy.props.CollectionProperty(type=AddonInfo)
    addon_info_for_renaming_image_editor:bpy.props.CollectionProperty(type=AddonInfoRename)
    addon_info_image_editor_index: bpy.props.IntProperty(default=0,name="Selected Tab")
    addon_info_for_renaming_image_editor_index: bpy.props.IntProperty(default=0,name="Selected Addon")
    addon_info_node_editor:bpy.props.CollectionProperty(type=AddonInfo)
    addon_info_for_renaming_node_editor:bpy.props.CollectionProperty(type=AddonInfoRename)
    addon_info_node_editor_index: bpy.props.IntProperty(default=0,name="Selected Tab")
    addon_info_for_renaming_node_editor_index: bpy.props.IntProperty(default=0,name="Selected Addon")
    injected_code: bpy.props.BoolProperty(default=check_for_injection())
    injected_code_tracking: bpy.props.BoolProperty(default=check_for_tracking_injection())
    delayed_loading_code_injected:bpy.props.BoolProperty(default=check_for_delayed_loading_injection())
    columm_layout_for_popup: bpy.props.BoolProperty(default=True,name="Use Column Layout (Dropdowns will be stacked)",update=savePreferences)
    use_verticle_menu: bpy.props.BoolProperty(default=True,name="Use list instead of 2nd pie menu")
    dropdown_width: bpy.props.IntProperty(default=16,name="Dropdown Width",min=5,max=50)
    show_dropdown_search: bpy.props.BoolProperty(default=False,name="Show Dropdown search button")
    categories:bpy.props.PointerProperty(type=Category_Indices)
    #filtering_method: bpy.props.BoolProperty(default=False,name="Use Unregister/Reregister Method for filtering (Restart after changing this)")
    filtering_method: bpy.props.EnumProperty(items=(("Use Workspace Filtering","Use Workspace Filtering","Use Workspace Filtering"),("Use N-Panel Filtering","Use N-Panel Filtering","Use N-Panel Filtering")),default=1,name="How to clean the N-Panel (Restart after changing this)")
    show_advanced: bpy.props.BoolProperty(default=False,name='Show Advanced Options')
    use_dropdowns: bpy.props.BoolProperty(default=True,name="Show Dropdowns")
    sort_per_category:bpy.props.BoolProperty(default=False,name="Sort Panels per Category",description="Sort Panels based on the order specified in the categories")
    holder_tab_name: bpy.props.StringProperty(default="DUMP",name="Tab name for filtered out addons")
    remove_holder_tab: bpy.props.BoolProperty(default=True,name="Remove Holder Tab",update=remove_holder_tab_update)
    custom_icons_dir: bpy.props.StringProperty(default="",name="Custom Icons Directory",update=reload_icons,subtype='DIR_PATH')
    sort_focus_menu_based_on_clicks:bpy.props.BoolProperty(default=False,name="Sort Focus Panel List based on clicks")
    addon_desc_info:bpy.props.CollectionProperty(type=AddonDescriptionInfo)
    filtering_per_workspace:bpy.props.BoolProperty(default=False,name="Use Filtering Per Workspace",description="Have different sets of categories enabled for different workspaces")
    only_show_unfiltered_panels:bpy.props.BoolProperty(default=False,name="Only show unfiltered panels in the Focus Panels list")
    show_delete_buttons_in_quick_settings:bpy.props.BoolProperty(default=False,name="Show delete buttons in Quick Settings Panel")
    move_dropdowns_to_toolbar:bpy.props.BoolProperty(default=False,name="Show in Toolbar (Same row as the Filter Options)",update=draw_side_changed)
    space_type:bpy.props.EnumProperty(items=[('VIEW_3D','Viewport','Viewport'),('NODE_EDITOR','Node Editor','Shader/Geometry Node Editor'),('IMAGE_EDITOR','Image/UV Editor','Image Editor')],default=0,name="Space Type")
    favorites:bpy.props.CollectionProperty(type=CP_Panel_Category)
    filter_internal_tabs:bpy.props.BoolProperty(default=False,name="Filter Internal Tabs(View, Tool, Node and Options)")
    delayed_addons_loaded:bpy.props.BoolProperty(default=False)
    atl_list:bpy.props.StringProperty(default="",name="Addons to load on boot")
    show_pro_options:bpy.props.BoolProperty(default=False,name="Pro Features")
    show_enabledisable_in_quick_settings:bpy.props.BoolProperty(default=False,name="Show Enable/Disable Addons in Quick Settings")
    def draw(self, context):
        layout2 = draw_settings(self,self,context)
        self.draw_pro_settings(layout2)
        layout3 = layout2.box()
        row= layout3.row(align=True)
        
        row.operator("cp.exportconfig",icon='EXPORT')
        row.operator("cp.importconfig",icon='IMPORT')
        row.operator('cp.importconfig',icon='IMPORT',text='Import Backup Config').directory=os.path.join(os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))), "config","CP-Backups")

    def draw_pro_settings(self, layout2):
        layout3 = layout2.box()
        row = layout3.row(align=True)
        row.alignment = 'LEFT'
        row.prop(self, "show_pro_options", emboss=False,
                icon="TRIA_DOWN" if self.show_pro_options else "TRIA_RIGHT")
        if self.show_pro_options:
            row=layout3.row()
            row=row.split(factor=0.8)
            
            row.operator("cp.enabledelayedloading",text="Enable Delayed Addon Loading" if not preferences().delayed_loading_code_injected else "Disable Delayed Addon Loading",depress=preferences().delayed_loading_code_injected)
            row.operator("cp.enableaddons",icon='FILE_REFRESH',)
            if preferences().delayed_loading_code_injected:
                row2=layout3.row()
                row2=row2.split(factor=0.8)
                row2.prop(self,f"atl_list")
                row2.operator("cp.setatl",text="",icon="ADD",depress=True)
                if preferences().atl_list:
                    grid=layout3.grid_flow(columns=4,row_major=True)
                    for panel in split_keep_substring(preferences().atl_list):
                        if panel:
                            op=grid.operator("cp.remove_panel",text=panel,icon='PANEL_CLOSE')
                            op.index=1
                            op.panel=panel
                            op.category="ATL"
            layout3.separator()
            row=layout3.row()
            row.operator("cp.exportaddonslist",icon='EXPORT')
class PAP_Import_Workspaces(bpy.types.Operator):
    bl_idname = "cp.importworkspaces"
    bl_label = "Import Workspaces as Categories"
    bl_description="Create categories from all available workspaces which have filtering enabled"
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    name: bpy.props.StringProperty()
    def invoke(self, context, event):
        for w in bpy.data.workspaces:
            if w.use_filter_by_owner:
                t=getattr(preferences(),f"workspace_categories{get_active_space()}").add()
                t.name=w.name
                t.panels=",".join([c.name for c in w.owner_ids if c.name not in split_keep_substring(getattr(preferences(),f'addons_to_exclude{get_active_space()}'))+addons_to_exclude])
        savePreferences()
        return {"FINISHED"}

class PAP_Addon_Info(bpy.types.Operator):
    bl_idname = "cp.addonsinfo"
    bl_label = "Enable/Disable Addons"
    bl_description="Enable/Disable addons or add notes about their functionality"
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    def draw(self,context):
        layout=self.layout
        box=layout.box()
        box.label(text='Enabled:')
        grid=box.grid_flow(columns=int(len(self.disabled_addons+self.enabled_addons)/29))
        for module,name in self.enabled_addons:
            is_enabled=module.__name__ in {ext.module for ext in context.preferences.addons}
            row=grid.row()
            
            row.operator(
                    "preferences.addon_disable" if is_enabled else "preferences.addon_enable",
                    icon='CHECKBOX_HLT' if is_enabled else 'CHECKBOX_DEHLT', text="",
                    emboss=False,
                ).module = module.__name__
            row=row.split(factor=0.9)
            row.label(text=name)
            row.operator("cp.addonsdescription",text='',icon='INFO',emboss=False).module_name=module.__name__
        box=layout.box()
        box.label(text='Disabled:')
        grid=box.grid_flow(columns=int(len(self.disabled_addons+self.enabled_addons)/29))
        for module,name in self.disabled_addons:
            is_enabled=module.__name__ in {ext.module for ext in context.preferences.addons}
            row=grid.row()
            row.operator(
                    "preferences.addon_disable" if is_enabled else "preferences.addon_enable",
                    icon='CHECKBOX_HLT' if is_enabled else 'CHECKBOX_DEHLT', text="",
                    emboss=False,
                ).module = module.__name__
            row=row.split(factor=0.9)
            row.label(text=name)
            row.operator("cp.addonsdescription",text='',icon='INFO',emboss=False).module_name=module.__name__
    def execute(self, context):
        return {'FINISHED'}
    def invoke(self, context, event):
        import addon_utils
        self.enabled_addons=[(a,addon_utils.module_bl_info(a)['name']) for a in addon_utils.modules() if addon_utils.check(a.__name__)[1]]
        self.disabled_addons=[(a,addon_utils.module_bl_info(a)['name']) for a in addon_utils.modules() if not addon_utils.check(a.__name__)[1]]
        self.enabled_addons=sorted(self.enabled_addons,key=lambda x: x[1].lower())
        self.disabled_addons=sorted(self.disabled_addons,key=lambda x: x[1].lower())
        return context.window_manager.invoke_props_dialog(self,width=200*int(len(self.disabled_addons+self.enabled_addons)/29))
class PAP_Addon_Description(bpy.types.Operator):
    bl_idname = "cp.addonsdescription"
    bl_label = "Addons Description"
    bl_description="Info about the addon"
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    module_name:bpy.props.StringProperty()
    def draw(self,context):
        layout=self.layout
        layout.label(text='',icon='INFO')
        lines = textwrap.wrap(self.desc,100, break_long_words=False)
        for l in lines:
            row=layout.row()
            row.label(text=l)
        # row.label(text=self.desc)
        row.operator("cp.editdescription",text='',icon='GREASEPENCIL').module_name=self.module_name
    def execute(self, context):
        return {'FINISHED'}
    def invoke(self, context, event):
        import addon_utils
        self.desc=addon_utils.module_bl_info([a for a in addon_utils.modules() if a.__name__ ==self.module_name][0])['description']
        if preferences().addon_desc_info.find(self.module_name)>=0:
            self.desc=preferences().addon_desc_info[preferences().addon_desc_info.find(self.module_name)].desc
        return context.window_manager.invoke_popup(self,width=550 if len(self.desc) > 70 else 300)
class PAP_Addon_Edit_Description(bpy.types.Operator):
    bl_idname = "cp.editdescription"
    bl_label = "Edit Description"
    bl_description="Edit Info about the addon"
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    module_name:bpy.props.StringProperty()
    def draw(self,context):
        layout=self.layout.row()
        layout.label(text='',icon='INFO')
        layout.prop(self.info,'desc')
    def execute(self, context):
        return {'FINISHED'}
    def invoke(self, context, event):
        if not preferences().addon_desc_info.find(self.module_name)>=0:
            temp=preferences().addon_desc_info.add()
            temp.name=self.module_name
            temp.desc=addon_utils.module_bl_info([a for a in addon_utils.modules() if a.__name__ ==self.module_name][0])['description']
            self.info=temp
        else:
            self.info=preferences().addon_desc_info[preferences().addon_desc_info.find(self.module_name)]
        return context.window_manager.invoke_props_dialog(self,width=500)
class CP_OT_Fetch_Categories(bpy.types.Operator):
    bl_idname = "cp.autocreatecategories"
    bl_label = "Fetch from Online Database"
    bl_description="Create categories automatically by fetching from online database"
    def execute(self, context):
        fetch_categories()
        return {'FINISHED'}
    
    