# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
import os
from webbrowser import get
import bpy
import re
import sys
import rna_keymap_ui
import importlib
from bpy.types import (PropertyGroup,Menu)
from bpy.app.handlers import persistent
import addon_utils
from bpy_extras.io_utils import ExportHelper,ImportHelper
from datetime import datetime
import bpy.utils.previews
from bpy.app.handlers import persistent
from .utils import *
import inspect



    

            
def reload_lists():
    if preferences().filtering_method=="Use N-Panel Filtering":
        #workspace_category_enabled(preferences().categories,bpy.context)
        # print("Loading Lists")
        load_renaming_list(bpy.context)
        load_reordering_list(bpy.context)
        load_renaming_list(bpy.context,space="IMAGE_EDITOR")
        load_reordering_list(bpy.context,space="IMAGE_EDITOR")
        load_renaming_list(bpy.context,space="NODE_EDITOR")
        load_reordering_list(bpy.context,space="NODE_EDITOR")
class PAP_Enable_Category(bpy.types.Operator):
    bl_idname = "cp.enablecategory"
    bl_label = ""
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"
    name: bpy.props.StringProperty()
    index: bpy.props.IntProperty()
    @classmethod
    def description(self, context,properties):
        return getattr(preferences(),f"workspace_categories{get_active_space(context.area.type)}")[properties.index].name
    def invoke(self, context, event):
        if not preferences().filtering_method=="Use N-Panel Filtering":
            enabled=[getattr(context.workspace.category_indices,f'enabled{get_active_space(context.area.type)}_{i}') for i in range(50) if getattr(context.workspace.category_indices,f'enabled_{i}')]
            
            if not event.shift:
                for a in range(50):
                    if a!=self.index:
                        setattr(context.workspace.category_indices,f"enabled{get_active_space(context.area.type)}_{a}",False)        
            if len(enabled)>1 and not event.shift:
                setattr(context.workspace.category_indices,f"enabled{get_active_space(context.area.type)}_{self.index}",True)
            else:
                
                setattr(context.workspace.category_indices,f"enabled{get_active_space(context.area.type)}_{self.index}",not getattr(context.workspace.category_indices,f"enabled_{self.index}",False))
            workspace_category_enabled(context.workspace.category_indices,context)
        else:
            enabled=[getattr(preferences().categories,f'enabled{get_active_space(context.area.type)}_{i}') for i in range(50) if getattr(preferences().categories,f'enabled{get_active_space(context.area.type)}_{i}')]
            
            if not event.shift:
                for a in range(50):
                    if a!=self.index:
                        setattr(preferences().categories,f"enabled{get_active_space(context.area.type)}_{a}",False)        
            if len(enabled)>1 and not event.shift:
                setattr(preferences().categories,f"enabled{get_active_space(context.area.type)}_{self.index}",True)
            else:
                
                setattr(preferences().categories,f"enabled{get_active_space(context.area.type)}_{self.index}",not getattr(preferences().categories,f"enabled{get_active_space(context.area.type)}_{self.index}",False))
            
            workspace_category_enabled(preferences().categories,context)
            
        return {"FINISHED"}